<?php
/**
 * Configuration: Global
 *	- phpCOIN is based on concept and code of Mike Lansberry <mg@mgwebhosting.com>
 *	- Do NOT alter or remove this text block
 * @package phpCOIN
 * @subpackage Configuration
 * @version 1.4
 * @author Stephen M. Kitching <support@phpcoin.com>
 * @copyright Copyright  2003-2008 COINSoftTechnologies Inc. All rights reserved.
 * @license coin_docs/license.txt phpCOIN License Terms
 * @translation
 * @arguments
 */


# Code to handle file being loaded by URL
	IF (eregi('config.php', $_SERVER['PHP_SELF'])) {
		require_once('coin_includes/session_set.php');
		require_once('coin_includes/redirect.php');
		html_header_location('error.php?err=01');
		exit();
	}

# Dim misc globals. Do NOT touch this line
    global $_GPV, $_CCFG, $_TCFG, $_DBCFG, $_UVAR, $_LANG, $_nl, $_sp;


/**************************************************************
 * Configuration Variables That MUST be edited
**************************************************************/

# Database Configuration Array
	$_DBCFG['dbms'] 			= "mysql";				// Database System (type)
	$_DBCFG['dbhost'] 			= "localhost";				// Database Host
	$_DBCFG['dbuname'] 			= "username";				// User
	$_DBCFG['dbpass'] 			= "password";				// Password
	$_DBCFG['dbname'] 			= "database";				// Database Name
	$_DBCFG['table_prefix'] 		= "phpcoin_";				// Database table prefix


# Mailserver settings
	$_SMTP['AUTHENTICATED']	= 0;							// 1 = mailserver requires authenticated session,
													// 0 = does NOT require authentication
	# The following need to be set ONLY if $_SMTP[AUTHENTICATION] = 1
	$_SMTP['HOST']				= 'mail.yourdomain.com';		// FQDN or IP Address of your mailserver
	$_SMTP['LOCALHOST']			= 'www.yourdomain.com';		// name of machine sending email, for HELO
	$_SMTP['ACC']				= 'email@yourdomain.com';	// mailserver user name
	$_SMTP['PASS']				= 'yourpassword';			// mailserver user password


# Offline flag to initiate redirect in core load (1=offline,0=normal)
	$_CCFG['_PKG_MODE_OFFLINE'] 	= 0;

# Ignore Offline Flag if surfer is from THIS IP (allows admin to see site as normal)
# Seperate multiple IPs with commas
	$_CCFG['_PKG_MODE_ONLINE_IP']	= '';


# Define laguage file / decoding
	$_CCFG['_HC_PKG_LANG']		= 'lang_english';			// Use this lang if the next line is 0
	$_CCFG['_DB_PKG_LANG_ENABLE']	= 1;						// Use the lang in the database

	$_CCFG['ISO_CHARSET']		= 'iso-8859-1';			// Charset used for input and output. All legal charsets allowed, including UTF-8


# Theme settings
	$_CCFG['_HC_PKG_THEME']			= 'earthtone';			// Use this theme if the next line is 0
	$_CCFG['_DB_PKG_THEME_ENABLE']	= 1;					// Use the theme in the database



# Shows or hides debug info for MySQL queries and server loads at page bottom
# Leave this 0 for production use, 1 if you have MySQL query errors but do not know why
	$_CCFG['_debug_queries']			= 0;


# If you have some themes or modules written for phpCOIN v1.3.1 or lower, you
# can either re-write them according to /coin_docs/readme.txt OR you may simply
# enable "compatibility mode". We recommend re-writing so you do not lose the
# speed advantages of phpCOIN v1.4.0
	$_CCFG['ENABLE_COMPATIBILITY_MODE'] = 0;


# Google Adsense Ad Code
# Replace this with your own code, if you have a Google Adsense Account
# 120 x 600 Tower, for placing in side menu-box OR in siteinfo or FAQ or pages
# The tag %GOOGLE_V% will be replaced with the following
	$_CCFG['ADSENSE_VERTICAL']	='<script type="text/javascript"><!--
google_ad_client = "pub-4629014099185225";
/* phpCOIN Download 120x600 */
google_ad_slot = "2508894821";
google_ad_width = 120;
google_ad_height = 600;
//-->
</script>
<script type="text/javascript"
src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>';


# Google Adsense Ad Code
# Replace this with your own code, if you have a Google Adsense Account
# 120 x 600 Horizontal, for placing in siteinfo or FAQ or pages.
# The tag %GOOGLE_H% will be replaced with the following
	$_CCFG['ADSENSE_HORIZONTAL']	='<script type="text/javascript"><!--
google_ad_client = "pub-4629014099185225";
/* phpCOIN Download 728x90 */
google_ad_slot = "3359862896";
google_ad_width = 728;
google_ad_height = 90;
//-->
</script>
<script type="text/javascript"
src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
</script>';




# All fields of a client-to-site contact form and all fields of an order and
# the content of helpdesk ticket or additional messages is checked against this
# array. If anything matches, it is replaced with a **** string.
# This is intended to prevent hack attempts, but could just as easily be used
# to remove swear words :)
# To add, just copy line and change value
	$_CCFG['PARSE_USER_ENTRY'][]	= '<a';
	$_CCFG['PARSE_USER_ENTRY'][]	= 'href';
	$_CCFG['PARSE_USER_ENTRY'][]	= '<img';
	$_CCFG['PARSE_USER_ENTRY'][]	= '<script';
	$_CCFG['PARSE_USER_ENTRY'][]	= '<iframe';
	$_CCFG['PARSE_USER_ENTRY'][]	= 'javascript';
	$_CCFG['PARSE_USER_ENTRY'][]	= 'vbscript';



/**************************************************************
 * Misc Vars
 * There is normally NO need to edit these,
 * unless specifically instructed to do so
 **************************************************************/

IF (!defined('CONFIGGED')) {
# Parameter Group Select List Params (do not change )
	$_CCFG['_PARM_GROUP'][]		= 'automation';
	$_CCFG['_PARM_GROUP'][]		= 'common';
	$_CCFG['_PARM_GROUP'][]		= 'theme';
	$_CCFG['_PARM_GROUP'][]		= 'user';
	$_CCFG['_PARM_GROUP'][]		= 'undefined';

# Parameter Sub-Group Select List Params (Do NOT delete or edit)
	$_CCFG['_PARM_GROUP_SUB'][]	= 'admin';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'API';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'articles';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'backup';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'bills';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'buttons';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'clients';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'common';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'contacts';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'domains';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'downloads';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'faq';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'helpdesk';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'invoices';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'ipn';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'layout';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'module';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'operation';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'orders';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'package';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'pages';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'siteinfo';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'style';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'summary';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'summary';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'todo';
	$_CCFG['_PARM_GROUP_SUB'][]	= 'whois';

# Countries List
	$_Countries = array('Afghanistan', 'Albania', 'Algeria', 'American Samoa', 'Andorra', 'Angola', 'Anguilla', 'Antarctica', 'Antigua & Barbuda', 'Argentina', 'Armenia', 'Aruba', 'Australia', 'Austria', 'Azerbaijan', 'Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bolivia', 'Bosnia & Herzegowina', 'Botswana', 'Bouvet Island', 'Brazil', 'British Indian Ocean Territory', 'Brunei Darussalam', 'Bulgaria', 'Burkina Faso', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 'Chad', 'Chile', 'China', 'Christmas Island', 'Cocos (Keeling) Islands', 'Colombia', 'Comoros', 'Congo', 'Cook Islands', 'Costa Rica', 'Cote D\'Ivoire', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Falkland Islands (Malvinas)', 'Faroe Islands', 'Fiji', 'Finland', 'France', 'France, Metropolitan', 'French Guiana', 'French Polynesia', 'French Southern Territories', 'Gabon', 'Gambia', 'Georgia', 'Germany', 'Ghana', 'Gibraltar', 'Greece', 'Greenland', 'Grenada', 'Guadeloupe', 'Guam', 'Guatemala', 'Guinea', 'Guinea-bissau', 'Guyana', 'Haiti', 'Heard & McDonald Islands', 'Honduras', 'Hong Kong', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iran, Islamic Republic of', 'Iraq', 'Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'Korea, Democratic People\'s Republic of', 'Korea, Republic of', 'Kuwait', 'Kyrgyzstan', 'Lao People\'s Democratic Republic', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libyan Arab Jamahiriya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Macau', 'Macedonia, (former) Yugoslav Republic of', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Martinique', 'Mauritania', 'Mauritius', 'Mayotte', 'Mexico', 'Micronesia, Federated States of', 'Moldova, Republic of', 'Monaco', 'Mongolia', 'Montserrat', 'Morocco', 'Mozambique', 'Myanmar', 'Namibia', 'Nauru', 'Nepal', 'Netherlands', 'Netherlands Antilles', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Niue', 'Norfolk Island', 'Northern Mariana Islands', 'Norway', 'Oman', 'Pakistan', 'Palau', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Pitcairn', 'Poland', 'Portugal', 'Puerto Rico', 'Qatar', 'Reunion', 'Romania', 'Russian Federation', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent & the Grenadines', 'Samoa', 'San Marino', 'Sao Tome & Principe', 'Saudi Arabia', 'Senegal', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia (Slovak Republic)', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Georgia & South Sandwich Islands', 'Spain', 'Sri Lanka', 'St. Helena', 'St. Pierre & Miquelon', 'Sudan', 'Suriname', 'Svalbard & Jan Mayen Islands', 'Swaziland', 'Sweden', 'Switzerland', 'Syrian Arab Republic', 'Taiwan, Province of China', 'Tajikistan', 'Tanzania, United Republic of', 'Thailand', 'Togo', 'Tokelau', 'Tonga', 'Trinidad & Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Turks & Caicos Islands', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'US, Minor Outlying Islands', 'Uzbekistan', 'Vanuatu', 'Vatican City State (Holy See)', 'Venezuela', 'Viet Nam', 'Virgin Islands (British)', 'Virgin Islands (U.S.)', 'Wallis & Futuna Islands', 'Western Sahara', 'Yemen', 'Yugoslavia', 'Zaire', 'Zambia', 'Zimbabwe');




/**************************************************************
 * Other Vars Paths / Dirs
 * Do NOT edit these, nor touch anything below this line
 **************************************************************/
# Some formatting strings
	$_nl	= "\n";
	$_sp	= "&nbsp;";


# Common paths and URLs
	define('PKG_REDIRECT_ROOT', $_PACKAGE['URL']);

	define('PKG_URL_BASE', $_PACKAGE['URL']);
	define('PKG_PATH_BASE', $_PACKAGE['DIR']);

	define('PKG_URL_INCL', PKG_URL_BASE.'coin_includes/');
	define('PKG_PATH_INCL', PKG_PATH_BASE.'coin_includes/');

	define('PKG_URL_MDLS', PKG_URL_BASE.'coin_modules/');
	define('PKG_PATH_MDLS', PKG_PATH_BASE.'coin_modules/');

	define('PKG_URL_ADDONS', PKG_URL_BASE.'coin_addons/');
	define('PKG_PATH_ADDONS', PKG_PATH_BASE.'coin_addons/');

	define('PKG_PATH_OVERRIDES', PKG_PATH_BASE.'coin_overrides/');

	define('PKG_PATH_ADMN', PKG_PATH_BASE.'coin_admin/');
	define('PKG_PATH_AUXP', PKG_PATH_BASE.'coin_auxpages/');
	define('PKG_PATH_DBSE', PKG_PATH_BASE.'coin_database/');

	define('PKG_URL_IMGS', PKG_URL_BASE.'coin_images/');
	define('PKG_PATH_IMGS', PKG_PATH_BASE.'coin_images/');

# The paths and URLs for the theme and lang are now specified within the session_xxxx.php files, AFTER loading any override files


# "action" of default page shown to clients upon login.
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][1]	= 'cc';
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][2]	= 'clients';
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][3]	= 'domains';
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][4]	= 'invoices';
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][5]	= 'helpdesk';
	$_CCFG['CLIENT_VIEW_PAGE_UPON_LOGIN_ACTION'][6]	= 'orders&mode=view';

# Config loaded flag, to prevent double-loading of arrays
	define('CONFIGGED', 1);
}
?>