CREATE TABLE %PREFIX%admins (`admin_id` smallint(6) NOT NULL auto_increment, `admin_user_name` varchar(30) NOT NULL default '', `admin_user_pword` varchar(100) NOT NULL default '', `admin_name_first` varchar(20) NOT NULL default 'none', `admin_name_last` varchar(20) NOT NULL default 'none', `admin_email` varchar(50) NOT NULL default 'none', `admin_perms` int(11) NOT NULL default 0, PRIMARY KEY (admin_id), UNIQUE KEY `user_name` (admin_user_name)) TYPE=MyISAM COMMENT='Site Admins Table' AUTO_INCREMENT=2;
INSERT INTO %PREFIX%admins (`admin_id`, `admin_user_name`, `admin_user_pword`, `admin_name_first`, `admin_name_last`, `admin_email`, `admin_perms`) VALUES (1, 'webmaster', '%PASSWORD%', 'none', 'none', 'webmaster@%DOMAINNAME%', 65535);
CREATE TABLE %PREFIX%articles (id int(9) NOT NULL auto_increment, subject varchar(50) NOT NULL default '', topic_id int(11) NOT NULL default 1, cat_id int(11) NOT NULL default 1, time_stamp varchar(10) default NULL, entry mediumtext NOT NULL, followup_cnt int(9) NOT NULL default 0, auto_nl2br tinyint(1) NOT NULL default 1, PRIMARY KEY (id)) TYPE=MyISAM COMMENT='Site Articles Module Table' AUTO_INCREMENT=2;
INSERT INTO %PREFIX%articles (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `entry`, `followup_cnt`, `auto_nl2br`) VALUES (1, 'Welcome to our phpCOIN powered site', 1, 1, '%TIMESTAMP%', 'Just to note we are now running the phpCOIN package.\r\n\r\nCheck back for more info.', 0, 1);
CREATE TABLE %PREFIX%banned (banned_ip varchar(15) NOT NULL default '') TYPE=MyISAM COMMENT='Site Banned IP Address Table';
INSERT INTO %PREFIX%banned (`banned_ip`) VALUES ('000.000.000.000');
CREATE TABLE %PREFIX%categories (cat_id int(11) NOT NULL auto_increment, cat_pos smallint(6) NOT NULL default 0, cat_name varchar(50) NOT NULL default '', cat_desc varchar(50) NOT NULL default '', cat_icon smallint(6) NOT NULL default 1, PRIMARY KEY (cat_id), KEY cat_id (cat_id)) TYPE=MyISAM COMMENT='Site Categories Table' AUTO_INCREMENT=4;
INSERT INTO %PREFIX%categories (`cat_id`, `cat_pos`, `cat_name`, `cat_desc`, `cat_icon`) VALUES (1, 0, 'General', 'General / Default Category', 1);
INSERT INTO %PREFIX%categories (`cat_id`, `cat_pos`, `cat_name`, `cat_desc`, `cat_icon`) VALUES (2, 0, 'News', 'For News Items', 1);
INSERT INTO %PREFIX%categories (`cat_id`, `cat_pos`, `cat_name`, `cat_desc`, `cat_icon`) VALUES (3, 0, 'Site Related', 'For Site Related Items', 1);
CREATE TABLE %PREFIX%clients (cl_id int(11) NOT NULL default 0, cl_join_ts int(11) NOT NULL, cl_status varchar(20) NOT NULL default 'pending', cl_company varchar(50) NOT NULL default '', cl_name_first varchar(20) NOT NULL default '', cl_name_last varchar(20) NOT NULL default '', cl_addr_01 varchar(50) NOT NULL default '', cl_addr_02 varchar(50) NOT NULL default '', cl_city varchar(50) NOT NULL default '', cl_state_prov varchar(50) NOT NULL default '', cl_country varchar(50) NOT NULL default '', cl_zip_code varchar(12) NOT NULL default '', cl_phone varchar(20) NOT NULL default '', cl_email varchar(50) NOT NULL default '', cl_user_name varchar(100) NOT NULL default '', cl_user_pword varchar(100) NOT NULL default '', cl_notes text NOT NULL, cl_groups int(11) NOT NULL default 0, PRIMARY KEY (cl_id)) TYPE=MyISAM COMMENT='Site Clients Module Table';
CREATE TABLE %PREFIX%clients_contacts (contacts_id int(11) NOT NULL auto_increment, contacts_cl_id int(11) NOT NULL default 0, contacts_name_first varchar(20) NOT NULL default '', contacts_name_last varchar(20) NOT NULL default '', contacts_email varchar(50) NOT NULL default '', UNIQUE KEY contacts_id (contacts_id), KEY contacts_cl_id (contacts_cl_id)) TYPE=MyISAM AUTO_INCREMENT=1;
CREATE TABLE %PREFIX%components (comp_id mediumint(9) NOT NULL auto_increment, comp_type varchar(20) NOT NULL default '', comp_name varchar(20) NOT NULL default '', comp_mod varchar(20) NOT NULL default '', comp_desc varchar(50) NOT NULL default '', comp_ptitle varchar(50) NOT NULL default '', comp_col_num tinyint(1) NOT NULL default 3, comp_isadmin tinyint(1) NOT NULL default 0, comp_isuser tinyint(1) NOT NULL default 0, comp_status tinyint(1) NOT NULL default 1, PRIMARY KEY (comp_id), KEY comp_id (comp_id)) TYPE=MyISAM COMMENT='Site Components Table' AUTO_INCREMENT=36;
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (1, 'site', 'index', '', 'Site index', 'Home Page', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (2, 'site', 'login', '', 'Site Login', 'Site Login', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (3, 'admin', 'cp_reminders', '', 'Control Panel: Setup overdue invoice auto-reminder', 'Reminders', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (4, 'admin', 'cp_admins', '', 'Control Panel: Admins', 'Admin Admins', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (5, 'admin', 'cp_banip', '', 'Control Panel: Banned IP', 'Admin Banned IP', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (6, 'admin', 'cp_categories', '', 'Control Panel: Categories', 'Admin Categories', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (7, 'admin', 'cp_components', '', 'Control Panel: Components', 'Admin Components', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (8, 'admin', 'cp_icons', '', 'Control Panel: Icon', 'Admin Icons', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (9, 'admin', 'cp_index', '', 'Control Panel: Admin Menu', 'Admin Menu', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (10, 'admin', 'cp_mail_contacts', '', 'Control Panel: Mail Contacts', 'Admin Mail Contacts', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (11, 'admin', 'cp_mail_templates', '', 'Control Panel: Mail Templates', 'Admin Mail Templates', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (12, 'admin', 'cp_menu', '', 'Control Panel: Menu', 'Admin Menu', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (13, 'admin', 'cp_parms', '', 'Control Panel: Parameters', 'Admin Parameters', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (14, 'admin', 'cp_prods', '', 'Control Panel: Products', 'Admin Products', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (15, 'admin', 'cp_server_info', '', 'Control Panel: Server Info', 'Admin Server Info', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (16, 'admin', 'cp_siteinfo', '', 'Control Panel- Site Info', 'Admin SiteInfo', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (17, 'admin', 'cp_topics', '', 'Control Panel: Topics', 'Admin Topics', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (18, 'admin', 'cp_vendors', '', 'Control Panel: Vendors', 'Admin Vendors', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (19, 'admin', 'cp_vprods', '', 'Control Panel: Vendor Products', 'Admin Vendor Products', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (20, 'admin', 'cp_whois', '1', 'Control Panel: WHOIS Lookups', 'Admin: WHOIS Lookups', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (21, 'auxpage', 'auxpage_example', '', 'Auxpage', 'Auxpage Example', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (22, 'module', 'articles', '', 'Articles', 'Articles', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (23, 'module', 'clients', '', 'Clients', 'Clients', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (24, 'module', 'cc', '', 'Command Center', 'Command Center', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (25, 'module', 'domains', '', 'Domains', 'Domains', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (26, 'module', 'faq', '', 'FAQ Module', 'FAQ', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (27, 'module', 'helpdesk', '', 'HelpDesk Module', 'HelpDesk Support Tickets', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (28, 'module', 'invoices', '', 'Invoices', 'Invoices', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (29, 'module', 'mail', '', 'Mail Module', 'Mail', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (30, 'module', 'orders', '', 'Orders', 'Orders', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (31, 'module', 'pages', '', 'Pages', 'Documentation', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (32, 'module', 'search', '', 'Search Site', 'Search Site', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (33, 'module', 'siteinfo', '', 'Site Info Related Output', 'Site Info', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (34, 'module', 'whois', 'whois', 'WHOIS', 'WHOIS', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES (35, 'module', 'ipn', 'ipn', 'Instant Payment Notification', 'Instant Payment Notification', 2, 1, 0, 1);
INSERT INTO %PREFIX%components (`comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES ('module', 'ToDo', 'todo', 'ToDo List', 'ToDo List', 2, 1, 0, 1);
CREATE TABLE %PREFIX%domains (dom_id int(11) NOT NULL auto_increment, dom_cl_id int(11) NOT NULL default 0, dom_domain varchar(50) NOT NULL default '', dom_status tinyint(2) NOT NULL default 0, dom_type tinyint(2) NOT NULL default 0, dom_registrar varchar(32) NOT NULL default '', dom_ts_expiration varchar(10) NOT NULL default '', dom_sa_expiration varchar(10) NOT NULL default '', dom_si_id int(11) NOT NULL default 0, dom_ip varchar(16) NOT NULL default '', dom_path varchar(255) NOT NULL default '', dom_path_temp varchar(255) NOT NULL default '', dom_url_cp varchar(100) NOT NULL default '', dom_user_name_cp varchar(30) NOT NULL default '', dom_user_pword_cp varchar(30) NOT NULL default '', dom_user_name_ftp varchar(30) NOT NULL default '', dom_user_pword_ftp varchar(30) NOT NULL default '', dom_allow_domains smallint(6) NOT NULL default 0, dom_allow_subdomains smallint(6) NOT NULL default 0, dom_allow_disk_space_mb int(11) NOT NULL default 0, dom_allow_traffic_mb int(11) NOT NULL default 0, dom_allow_mailboxes smallint(6) NOT NULL default 0, dom_allow_databases smallint(6) NOT NULL default 0, dom_enable_www_prefix tinyint(1) NOT NULL default 0, dom_enable_wu_scripting tinyint(1) NOT NULL default 0, dom_enable_webmail tinyint(1) NOT NULL default 0, dom_enable_frontpage tinyint(1) NOT NULL default 0, dom_enable_fromtpage_ssl tinyint(1) NOT NULL default 0, dom_enable_ssi tinyint(1) NOT NULL default 0, dom_enable_php tinyint(1) NOT NULL default 0, dom_enable_cgi tinyint(1) NOT NULL default 0, dom_enable_mod_perl tinyint(1) NOT NULL default 0, dom_enable_asp tinyint(1) NOT NULL default 0, dom_enable_ssl tinyint(1) NOT NULL default 0, dom_enable_stats tinyint(1) NOT NULL default 0, dom_enable_err_docs tinyint(1) NOT NULL default 0, dom_notes text NOT NULL, PRIMARY KEY (dom_id)) TYPE=MyISAM COMMENT='Site Domains Module Table' AUTO_INCREMENT=1;
CREATE TABLE %PREFIX%downloads (`dload_id` int(11) NOT NULL auto_increment, `dload_group` varchar(50) NOT NULL default '', `dload_name` varchar(50) NOT NULL default '', `dload_desc` text NOT NULL, `dload_count` int(11) NOT NULL default '0', `dload_date_str` varchar(10) NOT NULL default 'yyyy-mm-dd', `dload_avail` int(1) NOT NULL default '0', `dload_filename` varchar(50) NOT NULL default '', `dload_filesize` varchar(8) NOT NULL default '', `dload_contributor` varchar(255) NOT NULL default '', PRIMARY KEY  (`dload_id`)) TYPE=MyISAM COMMENT='Downloads Table';
CREATE TABLE %PREFIX%faq (faq_id int(9) NOT NULL auto_increment, faq_position int(9) NOT NULL default 1, faq_time_stamp_mod varchar(10) default NULL, faq_status tinyint(1) NOT NULL default 0, faq_admin tinyint(1) NOT NULL default 0, faq_user tinyint(1) NOT NULL default 0, faq_title varchar(50) NOT NULL default '', faq_descrip mediumtext NOT NULL, PRIMARY KEY (faq_id)) TYPE=MyISAM COMMENT='Site FAQ Module Table' AUTO_INCREMENT=2;
CREATE TABLE %PREFIX%faq_qa (faqqa_id int(9) NOT NULL auto_increment, faqqa_faq_id int(11) NOT NULL default 0, faqqa_position int(9) NOT NULL default 1, faqqa_time_stamp_mod varchar(10) default NULL, faqqa_status tinyint(1) NOT NULL default 0, faqqa_question varchar(255) NOT NULL default '', faqqa_answer mediumtext NOT NULL, faqqa_auto_nl2br tinyint(1) NOT NULL default 1, PRIMARY KEY (faqqa_id)) TYPE=MyISAM COMMENT='Site FAQ Module QA Table' AUTO_INCREMENT=2;
INSERT INTO %PREFIX%faq_qa (`faqqa_id`, `faqqa_faq_id`, `faqqa_position`, `faqqa_time_stamp_mod`, `faqqa_status`, `faqqa_question`, `faqqa_answer`, `faqqa_auto_nl2br`) VALUES (1, 1, 1, '%TIMESTAMP%', 1, 'Welcome to phpcoin.', 'Congratulations on this installation of the phpCOIN (Clients, Order, Invoices, and Notes) package. Please be sure to perform the following:<br>\r\n<ul><li>Please review all documentation in the /coin_docs folder of the package distribution.\r\n<li>Please be sure set / verify the settings in the site config file.\r\n<li>Please be sure set / verify the settings in the theme config file.\r\n<li>Please be sure to backup your database after the initial setup is completed.\r\n</ul>\r\nPlease login to your admin control panel and set / verify required items.', 1);
CREATE TABLE %PREFIX%helpdesk (hd_tt_id int(11) NOT NULL default 0, hd_tt_cl_id int(11) NOT NULL default 0, hd_tt_cl_email varchar(50) NOT NULL default '', hd_tt_time_stamp varchar(10) default NULL, hd_tt_priority varchar(20) NOT NULL default '', hd_tt_category varchar(20) NOT NULL default '', hd_tt_subject varchar(50) NOT NULL default '', hd_tt_message text NOT NULL, hd_tt_cd_id int(11) NOT NULL default 0, hd_tt_url varchar(50) NOT NULL default '', hd_tt_status varchar(20) NOT NULL default '', hd_tt_closed int(1) NOT NULL default 0, hd_tt_rating int(1) NOT NULL default 0, PRIMARY KEY  (hd_tt_id)) TYPE=MyISAM COMMENT='Site HelpDesk Module Table';
CREATE TABLE %PREFIX%helpdesk_msgs (hdi_tt_id int(11) NOT NULL default 0, hdi_tt_time_stamp varchar(10) default NULL, hdi_tt_cl_id int(11) NOT NULL default 0, hdi_tt_ad_id int(11) NOT NULL default 0, hdi_tt_message text NOT NULL) TYPE=MyISAM COMMENT='Site HelpDesk Module Messages Table';
CREATE TABLE %PREFIX%icons (icon_id smallint(6) NOT NULL auto_increment, icon_name varchar(32) NOT NULL default '', icon_desc varchar(50) NOT NULL default '', icon_filename varchar(32) NOT NULL default 'default.gif', PRIMARY KEY (icon_id)) TYPE=MyISAM COMMENT='Site Icons Table' AUTO_INCREMENT=2;
INSERT INTO %PREFIX%icons (`icon_id`, `icon_name`, `icon_desc`, `icon_filename`) VALUES (1, 'default', 'Default', 'default.gif');
CREATE TABLE %PREFIX%invoices (invc_id int(11) NOT NULL default 0, invc_status varchar(20) NOT NULL default 'draft', invc_deliv_method varchar(10) NOT NULL default '', invc_delivered tinyint(1) NOT NULL default 0, invc_cl_id int(11) NOT NULL default 0, invc_total_cost double NOT NULL default '0', invc_total_paid double NOT NULL default '0', invc_subtotal_cost double NOT NULL default '0', invc_tax_01_percent double NOT NULL default '0', invc_tax_01_amount double NOT NULL default '0', invc_tax_02_percent double NOT NULL default '0', invc_tax_02_amount double NOT NULL default '0', invc_tax_autocalc tinyint(1) NOT NULL default 1, invc_ts int(11) NOT NULL, invc_ts_due int(11) NOT NULL, invc_ts_paid int(11) NOT NULL, invc_bill_cycle tinyint(1) NOT NULL default 1, invc_recurring tinyint(1) NOT NULL default 0, invc_recurr_proc tinyint(4) NOT NULL default 0, invc_last_nag_id int(11) NOT NULL default 0, invc_pay_link text NOT NULL, invc_terms text NOT NULL, PRIMARY KEY (invc_id)) TYPE=MyISAM COMMENT='Site Invoices Module Table';
CREATE TABLE %PREFIX%invoices_items (ii_invc_id int(11) NOT NULL default 0, ii_item_no smallint(4) NOT NULL default 0, ii_item_name varchar(30) NOT NULL default '', ii_item_desc varchar(75) NOT NULL default '', ii_item_cost double NOT NULL default '0', ii_apply_tax_01 tinyint(1) NOT NULL default 1, ii_apply_tax_02 tinyint(1) NOT NULL default 1, ii_calc_tax_02_pb tinyint(1) NOT NULL default 0, PRIMARY KEY (ii_invc_id,ii_item_no)) TYPE=MyISAM COMMENT='Site Invoices Module Items Table';
CREATE TABLE %PREFIX%invoices_trans (it_id bigint(11) NOT NULL auto_increment, it_ts int(11) NOT NULL, it_invc_id int(11) NOT NULL default 0, it_type tinyint(2) NOT NULL default 0, it_origin tinyint(2) NOT NULL default 0, it_desc varchar(50) NOT NULL default '', it_amount double NOT NULL default '0', PRIMARY KEY (it_id)) TYPE=MyISAM COMMENT='Site Invoices Module Transactions Table' AUTO_INCREMENT=1;
CREATE TABLE %PREFIX%ipn_log (`ipn_id` int(10) unsigned NOT NULL auto_increment, `ipn_ts` varchar(10) default NULL, `ipn_var_details` text, `ipn_txn` varchar(25) default NULL, `ipn_txn_type` varchar(100) default NULL, `ipn_cl_id` int(11) default NULL, `ipn_pay_amt` double default '0', `ipn_amt_applied` double default '0', `ipn_pay_stat` int(11) default NULL, `ipn_name_last` varchar(100) default NULL, `ipn_vendor` varchar(50) default NULL, PRIMARY KEY  (`ipn_id`)) TYPE=MyISAM;
CREATE TABLE %PREFIX%ipn_text (`id` int(6) unsigned NOT NULL auto_increment, `ipn_txn_id` varchar(25) default NULL, `ipn_text_ts` varchar(10) default NULL, `ipn_log_text` text, PRIMARY KEY  (`id`)) TYPE=MyISAM;
CREATE TABLE %PREFIX%mail_archive (ma_id bigint(11) NOT NULL auto_increment, ma_time_stamp varchar(10) default NULL, ma_fld_from varchar(100) NOT NULL default '', ma_fld_recip varchar(100) NOT NULL default '', ma_fld_cc varchar(100) NOT NULL default '', ma_fld_bcc varchar(100) NOT NULL default '', ma_fld_subject varchar(100) NOT NULL default '', ma_fld_message text NOT NULL, PRIMARY KEY (ma_id)) TYPE=MyISAM COMMENT='Site eMail Archive Table' AUTO_INCREMENT=1;
CREATE TABLE %PREFIX%mail_contacts (mc_id int(11) NOT NULL auto_increment, mc_name varchar(30) NOT NULL default '', mc_email varchar(50) NOT NULL default '', mc_status tinyint(1) NOT NULL default 1, PRIMARY KEY (mc_id)) TYPE=MyISAM COMMENT='Site Mail Contacts Table' AUTO_INCREMENT=5;
INSERT INTO %PREFIX%mail_contacts (`mc_id`, `mc_name`, `mc_email`, `mc_status`) VALUES (1, 'Billing', 'billing@%DOMAINNAME%', 1);
INSERT INTO %PREFIX%mail_contacts (`mc_id`, `mc_name`, `mc_email`, `mc_status`) VALUES (2, 'Orders', 'orders@%DOMAINNAME%', 1);
INSERT INTO %PREFIX%mail_contacts (`mc_id`, `mc_name`, `mc_email`, `mc_status`) VALUES (3, 'Support', 'support@%DOMAINNAME%', 1);
INSERT INTO %PREFIX%mail_contacts (`mc_id`, `mc_name`, `mc_email`, `mc_status`) VALUES (4, 'Webmaster', 'webmaster@%DOMAINNAME%', 1);
CREATE TABLE %PREFIX%mail_queue (mq_id bigint(11) NOT NULL default 0, mq_time_stamp varchar(10) default NULL, mq_fld_from varchar(100) NOT NULL default '', mq_fld_recip varchar(100) NOT NULL default '', mq_fld_cc varchar(100) NOT NULL default '', mq_fld_bcc varchar(100) NOT NULL default '', mq_fld_subject varchar(100) NOT NULL default '', mq_fld_message text NOT NULL, mq_sent_flag tinyint(1) NOT NULL default 0, PRIMARY KEY (mq_id)) TYPE=MyISAM COMMENT='Site eMail Queue Table';
CREATE TABLE %PREFIX%mail_templates (mt_id int(11) NOT NULL auto_increment, mt_name varchar(50) NOT NULL default '', mt_text text NOT NULL, PRIMARY KEY (mt_id)) TYPE=MyISAM COMMENT='Site eMail Templates Table';
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_password_reset', 'Hello $_MTP[username],\r\nThe following email from $_MTP[from_email] was triggered from a request to reset the password for this user name.\r\n\r\nThe new password is: $_MTP[password]\r\n\r\nPlease note the password has been reset. If you did not request the password change, we apologize for the inconvenience.\r\n\r\nAs a reminder, you can go to the following link to login and change you password.\r\n$_MTP[url]\r\n\r\n\r\n$_MTP[site] Support\r\n$_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_contact_form', 'Hello $_MTP[to_name],\r\nThe following email from $_MTP[from_name] was sent through the $_MTP[site] contact form. Note- the sender has also been copied on this email.\r\n\r\nMessage as follows:\r\n-------------------\r\nTo: $_MTP[to_name]\r\nFrom: $_MTP[from_name]\r\nEmail: $_MTP[from_email]\r\n\r\nSubject: $_MTP[subject]\r\n\r\nMessage:\r\n$_MTP[message]\r\n\r\n-------------------\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_contact_client_form', 'Hello $_MTP[to_name],\r\nThe following email from $_MTP[from_name] was sent through the $_MTP[site] contact client form. Note- the sender may also be copied on this email.\r\n\r\nMessage as follows:\r\n-------------------\r\nTo: $_MTP[to_name]\r\nFrom: $_MTP[from_name]\r\nEmail: $_MTP[from_email]\r\n\r\nSubject: $_MTP[subject]\r\n\r\nMessage:\r\n$_MTP[message]\r\n\r\n-------------------\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_profile_copy', 'Hello $_MTP[to_name],\r\nThe following client profile copy is from $_MTP[site] $_MTP[from_name] department.\r\n\r\n-------------------\r\n$_MTP[cl_info]\r\n-------------------\r\n\r\nThis profile information can be edited online at the following link (requires login):\r\n $_MTP[cl_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_order_ack', 'Hello $_MTP[to_name],\r\nThe following order acknowledgement is from $_MTP[site] $_MTP[from_name] department.\r\n\r\n-------------------\r\n$_MTP[order]\r\n-------------------\r\n\r\nThis order can be monitored online at the following link (requires login):\r\n $_MTP[ord_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_order_copy', 'Hello $_MTP[to_name],\r\nThe following order copy is from $_MTP[site] $_MTP[from_name] department.\r\n\r\n-------------------\r\n$_MTP[order]\r\n-------------------\r\n\r\nThis order can be monitored online at the following link (requires login):\r\n $_MTP[ord_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_trans_ack', 'Hello $_MTP[to_name],\r\nThe following email transaction acknowledgement is from $_MTP[site] $_MTP[from_name] department.\r\n\r\n Invoice ID:    $_MTP[invc_id]\r\n Invoice Date:  $_MTP[invc_ts]\r\n Date Due:      $_MTP[invc_ts_due]\r\n Date Paid:     $_MTP[invc_ts_paid]\r\n Status:        $_MTP[invc_status]\r\n                ----------------------\r\n Trans ID:      $_MTP[it_id]\r\n Date:          $_MTP[it_ts]\r\n Type:          $_MTP[it_type]\r\n Origin:        $_MTP[it_origin]\r\n Description:   $_MTP[it_desc]\r\n Amount:        $_MTP[it_amount]\r\n                ----------------------\r\n\r\nThe following is overall account balance with $_MTP[site] and includes all account activity:\r\n\r\n Acc Balance:  $_MTP[cl_balance]\r\n\r\nThis transaction can be viewed when visiting following link (requires login):\r\n $_MTP[invc_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_invoice_copy', 'Hello $_MTP[to_name],\r\nThe following email invoice is from $_MTP[site] $_MTP[from_name] department.\r\n\r\n Invoice ID:    $_MTP[invc_id]\r\n Invoice Date:  $_MTP[invc_ts]\r\n Date Due:      $_MTP[invc_ts_due]\r\n Terms:         $_MTP[invc_terms]\r\n Date Paid:     $_MTP[invc_ts_paid]\r\n Billing Cycle: $_MTP[invc_bill_cycle]\r\n\r\n Subtotal Due:  $_MTP[invc_subtotal_cost]\r\n Tax-01:        $_MTP[invc_tax_01_amount] ($_MTP[invc_tax_01_percent]%)\r\n Tax-02:        $_MTP[invc_tax_02_amount] ($_MTP[invc_tax_02_percent]%)\r\n                ----------------------\r\n Total Due:     $_MTP[invc_total_cost]\r\n\r\nOur Tax Registration Number: $_MTP[Company_TaxNo]\r\n(see below for items included in this invoice)\r\n\r\nThis invoice can be paid by clicking on the Payment Link when visiting following link (requires login):\r\n $_MTP[invc_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n $_MTP[Company_Name]\r\n\r\n\r\nThe following is a list of items included in this invoice:\r\n-------------------\r\n$_MTP[iitems]\r\n-------------------\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_invoice_copy_singleline', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated notification that a new invoice has been issued against your account.\r\nThis email summarizes the invoice, and the original can be viewed and/or printed by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nYou may have a prior debit or credit balance, in which case the amount we expect to receive from you is$_MTP[cl_balance].  You may login to the hosting control panel to see how this amount was determined.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]\r\n\r\nINVOICE DETAILS:\r\n================\r\nInvoice ID:     $_MTP[invc_id]\r\nInvoice Date:   $_MTP[invc_ts]\r\nDate Due:       $_MTP[invc_ts_due]\r\nTerms:          $_MTP[invc_terms]\r\nDate Paid:      $_MTP[invc_ts_paid]\r\nInvoice Amount: $_MTP[invc_total_cost]\r\nBilling Cycle:  $_MTP[invc_bill_cycle]\r\nNotes: $_MTP[invc_pay_link]\r\n\r\nLine   Item         Description                                      Cost\r\n-------------------------------------------------------------------------\r\n$_MTP[iitems]\r\n-------------------------------------------------------------------------\r\nSubtotal:  $_MTP[invc_subtotal_cost]\r\n$_CCFG[INVC_TAX_01_LABEL]       $_MTP[invc_tax_01_amount] ($_MTP[invc_tax_01_percent]%)\r\n$_CCFG[INVC_TAX_02_LABEL]       $_MTP[invc_tax_02_amount] ($_MTP[invc_tax_02_percent]%)\r\n=================================\r\nTotal:     $_MTP[invc_total_cost]\r\n\r\nOur Tax Registration: $_MTP[Company_TaxNo]');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_domain_acc_activate', 'Hello $_MTP[to_name],\r\n\r\nWelcome!  Thank you for choosing $_MTP[site] for your hosting needs.\r\n\r\nThis email contains vital information about your server account. Please read it thoroughly and print these pages or copy to a safe place.\r\n\r\n-------------------------------------------------------------\r\n1.	General Client Profile Information\r\n-------------------------------------------------------------\r\n\r\n$_MTP[cl_info]\r\n\r\n-------------------------------------------------------------\r\n2.	General Account Information\r\n-------------------------------------------------------------\r\n\r\nTo log into your account, please access:\r\n\r\n$_MTP[si_cp_url]\r\n or:\r\nhttps://$_MTP[si_ip]:$_MTP[si_cp_url_port]/login.php3\r\n\r\nServer Name:	$_MTP[si_name]\r\nIP Address:		$_MTP[si_ip]  (shared)\r\nDomain Name:	$_MTP[dom_domain]\r\nPOP Server:		mail.$_MTP[dom_domain]\r\nSMTP Server:	mail.$_MTP[dom_domain]\r\n\r\nNameservers:	$_MTP[si_ns_01]  (IP: $_MTP[si_ns_01_ip])\r\n				$_MTP[si_ns_02]  (IP: $_MTP[si_ns_02_ip])\r\n\r\nPlesk Username:	$_MTP[dom_user_name_cp]\r\nPlesk Password:	$_MTP[dom_user_pword_cp]\r\n\r\nFTP Username:	$_MTP[dom_user_name_ftp]\r\nFTP Password:	$_MTP[dom_user_pword_ftp]\r\nFTP URL:		ftp.$_MTP[dom_domain]  (once resolved)\r\n\r\nPlease remember that it will take a short time for your Registrar to process the delegation request and for this new DNS to propagate around the internet. During that time, you will not be able to access this site as normal through a web browser. However, you can still access your site during this period by pointing your browser to:\r\n\r\n		http://$_MTP[si_ip]/~$_MTP[dom_user_name_ftp]\r\n\r\nPlease note that CGI and PHP will not function properly while view your site through this special IP address. It is just a temporary measure to assist you in preparing your site while your new DNS transfer around the net.\r\n\r\nYou can upload your site by pointing your FTP software to your shared IP address ($_MTP[si_ip]). This means that you do not have to wait for your domain name to be transferred to our servers before you can upload your site. Once your domain has fully propagated around the net, you will be able to access your FTP account via your own domain name.\r\n\r\n\r\n-------------------------------------------------------------\r\n3.	Once your domain resolves:\r\n-------------------------------------------------------------\r\n\r\n	Your webmail URL is:	http://webmail.$_MTP[dom_domain]\r\n\r\n	Your Webstats URL is:	http://$_MTP[dom_domain]/webstat/\r\n	(stats can also be viewed from control panel)\r\n\r\n\r\n-------------------------------------------------------------\r\n4.	Setting Up An Email Account\r\n-------------------------------------------------------------\r\n\r\n	Before you can start sending or receiving email, you must\r\n	set up at least one email account.  To do this, please\r\n	follow the instructions below:\r\n\r\n	1. Log in to the control panel\r\n		($_MTP[si_cp_url])\r\n		using your control panel username and password.\r\n\r\n	2. Click on the MAIL button.\r\n\r\n	3. Enter the mail name that you want to create (i.e. "bob",\r\n		"editor", "webmaster" etc., not the full address).\r\n\r\n	4. Click on the ADD button\r\n\r\n	5. Check/Tick the "Mailbox" box\r\n\r\n	6. Enter and confirm a password that you would like to use\r\n\r\n	7. Scroll down to the bottom and click UPDATE\r\n\r\n\r\n-------------------------------------------------------------\r\n5.	Billing Information\r\n-------------------------------------------------------------\r\n\r\nFor increased security reasons we do not process credit cards ourselves on our servers. Depending on your selection of payment method when ordering, one of two third party processors will be used:\r\n\r\n	Paypal:			- Charge will appear as "Paypal"\r\n	Credit Card:	- Charge will appear as "2CheckOut.com Inc."\r\n\r\nRegardless of the method you selected, you will receive an order confirmation email detailing your order information.\r\n\r\nIf your email addresses changes, please notify us of your new email address and also update your profile in the control panel via the EDIT button.\r\n\r\n\r\n-------------------------------------------------------------\r\n6.	Support Methods\r\n-------------------------------------------------------------\r\n\r\nWhen looking for information or support. Please go through the motions:\r\n(see $_MTP[site] on the Client Tools menu for all these links)\r\n\r\na. FAQ Knowledgebase:\r\nFor general and other information, browse and search our FAQ:\r\n\r\n	http://www.yoursite.com/phpcoin/mod.php?mod=faq\r\n\r\n\r\nb. The $_MTP[site] Community:\r\nWe can\t stress enough, the importance of joining and participating in our community forums.  Often, you can find the answers to your questions just by searching for keywords or posting a question.  There are other members who can help you out with certain things that are not covered by our normal support options (Programming etc). You can also interact with $_MTP[site] staff, give us feedback and generally discuss our service at a community level.\r\n\r\n	http://forums.yoursite.com\r\n\r\nImportant note: The community is installed on a different server than the primary website. The reason for this is in the event you cannot reach the main site due to server issues, you should be able to reach the community for information and updates.\r\n\r\n\r\nc. HelpDesk:\r\nIf you require assistance please contact our Technical Support Team by submitting a support form. We will be happy to assist you. All support requests MUST be done using our ticket support system, which can be accessed at:\r\n\r\n	http://www.yoursite.com/phpcoin/mod.php?mod=helpdesk\r\n\r\n\r\nd. Quick Chat:\r\nFor immediate assistance, check the Quick Chat feature setup on the main site. Simply click on the "Quick Chat" link under the client Tools menu. Login and and quite possibly someone will be there who can assist you.\r\n\r\n\r\ne. Email Support:\r\nThis form of support is mostly used for sales, orders, or basic questions. Please view the Contacts Info link on the main site for up-to-date links for email options.\r\n\r\n\r\nf. Phone Support:\r\nCurrently, $_MTP[site] does not offer phone support.\r\n\r\n\r\nh. Regular Mail:\r\n\r\n	$_UVAR[CO_INFO_01_NAME]\r\n	c/o Customer Service\r\n	$_UVAR[CO_INFO_02_ADDR_01]\r\n	$_UVAR[CO_INFO_03_ADDR_02]\r\n	$_UVAR[CO_INFO_04_CITY], $_UVAR[CO_INFO_05_STATE_PROV]	$_UVAR[CO_INFO_06_POSTAL_CODE]\r\n	$_UVAR[CO_INFO_07_COUNTRY]\r\n\r\n	Phone:	$_UVAR[CO_INFO_08_PHONE]\r\n	Fax:	$_UVAR[CO_INFO_09_FAX]\r\n\r\nOnce again, this email contains vital information about your account. \r\nPlease read it thoroughly and print these pages or copy to a safe place.\r\n\r\nThank you again for choosing $_MTP[site] as your service provider.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_helpdesk_tt_update', 'Hello $_MTP[to_name],\r\nThe following email HelpDesk Ticket is from $_MTP[site] $_MTP[from_name] department and is the result of $_MTP[req_type].\r\n\r\nThis ticket can be viewed by clicking on the following link (requires login):\r\n $_MTP[tt_url]\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n\r\n------------------------------\r\n Ticket ID:    $_MTP[hd_tt_id]\r\n Date Opened:  $_MTP[hd_tt_time_stamp]\r\n Priority:     $_MTP[hd_tt_priority]\r\n Category:     $_MTP[hd_tt_category]\r\n Domain:       $_MTP[cd_cl_domain]\r\n\r\n Status:       $_MTP[hd_tt_status]\r\n Open/Closed:  $_MTP[hd_tt_closed]\r\n Rating:       $_MTP[hd_tt_rating]\r\n\r\n Subject:      $_MTP[hd_tt_subject]\r\n Message (below):\r\n ----------------\r\n$_MTP[hd_tt_message]\r\n------------------------------\r\n\r\nThe following is a listing of HelpDesk Support Ticket messages to date:\r\n\r\n$_MTP[tt_msgs]\r\n------------------------------\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_helpdesk_tt_alert', ' Ticket ID:    $_MTP[hd_tt_id]\r\n Priority:     $_MTP[hd_tt_priority]\r\n Subject:      $_MTP[hd_tt_subject]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_custom_order_request', 'Hello $_MTP[to_name],\r\nThe following email from $_MTP[from_name] was sent through the $_MTP[site] Custom Order Request system, and is a copy for your records.\r\n\r\nWe will be contacting you with the results of our processing the information you requested.\r\n\r\nThe following client profile was created as a result of your order request. In the event you choose to place the order, you can login to place the order.\r\n\r\n-------------------\r\n$_MTP[cl_info]\r\n-------------------\r\n\r\nThe following is the information you entered into the Custom Order Request form.\r\n\r\n-------------------\r\n$_MTP[cor_info]\r\n-------------------\r\n\r\n\r\nThank you for continuing to choose $_MTP[site] for your web service needs.\r\n\r\n $_MTP[from_name]\r\n $_MTP[from_email]\r\n');
INSERT INTO %PREFIX%mail_templates (`mt_id`, `mt_name`, `mt_text`) VALUES ('', 'email_contact_supplier_form', 'Hello $_MTP[to_name],\r\nThe following email from $_MTP[from_name] was sent through the $_MTP[site] contact supplier form.\r\n\r\nMessage as follows:\r\n-------------------\r\nTo: $_MTP[to_name]\r\nFrom: $_MTP[from_name]\r\nEmail: $_MTP[from_email]\r\n\r\nSubject: $_MTP[subject]\r\n\r\nMessage:\r\n$_MTP[message]\r\n\r\n-------------------\r\n');
CREATE TABLE %PREFIX%menu_blocks (block_id smallint(6) NOT NULL auto_increment, block_pos smallint(6) NOT NULL default 0, block_title varchar(30) NOT NULL default '', block_status tinyint(1) NOT NULL default 0, block_admin tinyint(1) NOT NULL default 0, block_user tinyint(1) NOT NULL default 0, block_col char(1) NOT NULL default 'L', PRIMARY KEY (block_id), UNIQUE KEY block_id (block_id)) TYPE=MyISAM COMMENT='Site Menu Blocks Table' AUTO_INCREMENT=5;
INSERT INTO %PREFIX%menu_blocks (`block_id`, `block_pos`, `block_title`, `block_status`, `block_admin`, `block_user`, `block_col`) VALUES (1, 1, 'Main Menu', 1, 0, 0, 'L');
INSERT INTO %PREFIX%menu_blocks (`block_id`, `block_pos`, `block_title`, `block_status`, `block_admin`, `block_user`, `block_col`) VALUES (2, 2, 'Administrator', 1, 1, 0, 'L');
INSERT INTO %PREFIX%menu_blocks (`block_id`, `block_pos`, `block_title`, `block_status`, `block_admin`, `block_user`, `block_col`) VALUES (3, 3, 'Client Tools', 1, 0, 0, 'L');
INSERT INTO %PREFIX%menu_blocks (`block_id`, `block_pos`, `block_title`, `block_status`, `block_admin`, `block_user`, `block_col`) VALUES (4, 4, 'Sponsored Links', 1, 0, 0, 'R');
INSERT INTO %PREFIX%menu_blocks (`block_id`, `block_pos`, `block_title`, `block_status`, `block_admin`, `block_user`, `block_col`) VALUES (5, 5, 'Misc. Links', 1, 0, 0, 'R');
CREATE TABLE %PREFIX%menu_blocks_items (block_id smallint(6) NOT NULL default 0, item_id smallint(6) NOT NULL default 0, item_text varchar(30) NOT NULL default '', item_url varchar(100) NOT NULL default '', item_target tinyint(1) NOT NULL default 0, item_type tinyint(1) NOT NULL default 0, item_status tinyint(1) NOT NULL default 1, item_admin tinyint(1) NOT NULL default 0, item_user tinyint(1) NOT NULL default 0, PRIMARY KEY (block_id,item_id)) TYPE=MyISAM COMMENT='Site Menu Blocks Items Table';
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (1, 1, 'Home', 'index.php', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (1, 3, 'About Us', 'mod.php?mod=siteinfo&id=4', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (1, 5, 'Contact Us', 'mod.php?mod=mail&mode=contact', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (2, 1, 'Admin', 'admin.php', 0, 0, 1, 1, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (2, 3, 'PHP-Info', 'phpinfo.php', 1, 0, 1, 1, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (2, 9, 'Logout', 'login.php?w=admin&o=logout', 0, 0, 1, 1, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (3, 1, 'Client Info.', 'mod.php?mod=clients', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (3, 3, 'Order Info.', 'mod.php?mod=orders&mode=view', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (3, 5, 'Invoice Info.', 'mod.php?mod=invoices', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (3, 7, 'Place Order', 'mod.php?mod=orders', 0, 0, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (3, 15, 'Log Out', 'login.php?w=user&o=logout', 0, 0, 1, 0, 1);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (4, 1, '_display_google_adsense', 'v', 0, 2, 1, 0, 0);
INSERT INTO %PREFIX%menu_blocks_items (`block_id`, `item_id`, `item_text`, `item_url`, `item_target`, `item_type`, `item_status`, `item_admin`, `item_user`) VALUES (5, 1, 'phpCOIN.com', 'http://www.phpcoin.com', 1, 0, 1, 0, 0);
CREATE TABLE %PREFIX%orders (ord_id int(11) NOT NULL default 0, ord_ts int(11) NOT NULL, ord_ip varchar(16) NOT NULL default '000.000.000.000', ord_status varchar(20) NOT NULL default 'pending', ord_cl_id int(11) NOT NULL default 0, ord_company varchar(50) NOT NULL default '', ord_name_first varchar(20) NOT NULL default '', ord_name_last varchar(20) NOT NULL default '', ord_addr_01 varchar(50) NOT NULL default '', ord_addr_02 varchar(50) NOT NULL default '', ord_city varchar(50) NOT NULL default '', ord_state_prov varchar(50) NOT NULL default '', ord_country varchar(50) NOT NULL default '', ord_zip_code varchar(12) NOT NULL default '', ord_phone varchar(20) NOT NULL default '', ord_email varchar(50) NOT NULL default '', ord_domain varchar(50) NOT NULL default '', ord_domain_action tinyint(1) NOT NULL default 0, ord_user_name varchar(20) NOT NULL default '', ord_user_pword varchar(50) NOT NULL default '', ord_vendor_id smallint(6) NOT NULL default 1, ord_prod_id smallint(6) NOT NULL default 0, ord_unit_cost double NOT NULL default '0', ord_accept_tos tinyint(1) NOT NULL default 0, ord_accept_aup tinyint(1) NOT NULL default 0, ord_referred_by varchar(50) NOT NULL default '', ord_comments text NOT NULL, ord_optfld_01 varchar(50) NOT NULL default '', ord_optfld_02 varchar(50) NOT NULL default '', ord_optfld_03 varchar(50) NOT NULL default '', ord_optfld_04 varchar(50) NOT NULL default '', ord_optfld_05 varchar(50) NOT NULL default '', ord_invc_id int(11) NOT NULL DEFAULT 0, PRIMARY KEY (ord_id)) TYPE=MyISAM COMMENT='Site Orders Module Table';
CREATE TABLE %PREFIX%orders_sessions (os_s_id varchar(36) NOT NULL default '', os_s_time_init int(11) NOT NULL default 0, os_s_time_last int(11) NOT NULL default 0, os_s_ip varchar(16) NOT NULL default '000.000.000.000', os_ord_processed tinyint(1) NOT NULL default 0, os_ord_ret_processed tinyint(1) NOT NULL default 0, os_ord_id int(11) NOT NULL default 0, os_ord_ts varchar(10) default NULL, os_ord_status varchar(20) NOT NULL default 'pending', os_ord_cl_id int(11) NOT NULL default 0, os_ord_company varchar(50) NOT NULL default '', os_ord_name_first varchar(20) NOT NULL default '', os_ord_name_last varchar(20) NOT NULL default '', os_ord_addr_01 varchar(50) NOT NULL default '', os_ord_addr_02 varchar(50) NOT NULL default '', os_ord_city varchar(50) NOT NULL default '', os_ord_state_prov varchar(50) NOT NULL default '', os_ord_country varchar(50) NOT NULL default '', os_ord_zip_code varchar(12) NOT NULL default '', os_ord_phone varchar(20) NOT NULL default '', os_ord_email varchar(50) NOT NULL default '', os_ord_domain varchar(50) NOT NULL default '', os_ord_domain_action tinyint(1) NOT NULL default 0, os_ord_user_name varchar(20) NOT NULL default '', os_ord_user_pword varchar(50) NOT NULL default '', os_ord_vendor_id smallint(6) NOT NULL default 1, os_ord_prod_id smallint(6) NOT NULL default 0, os_ord_unit_cost decimal(10,2) NOT NULL default '0.00', os_ord_accept_tos tinyint(1) NOT NULL default 0, os_ord_accept_aup tinyint(1) NOT NULL default 0, os_ord_referred_by varchar(50) NOT NULL default '', os_ord_comments text NOT NULL, os_ord_optfld_01 varchar(50) NOT NULL default '', os_ord_optfld_02 varchar(50) NOT NULL default '', os_ord_optfld_03 varchar(50) NOT NULL default '', os_ord_optfld_04 varchar(50) NOT NULL default '', os_ord_optfld_05 varchar(50) NOT NULL default '', os_ord_cbflag tinyint(1) NOT NULL default 0, os_ord_cbpaid tinyint(1) NOT NULL default 0, os_cor_flag tinyint(1) NOT NULL default 0, os_cor_type varchar(32) NOT NULL default '', os_cor_opt_bill_cycle varchar(32) NOT NULL default '', os_cor_opt_payment varchar(32) NOT NULL default '', os_cor_disk smallint(6) NOT NULL default 0, os_cor_disk_units char(3) NOT NULL default 'Mb', os_cor_traffic smallint(6) NOT NULL default 0, os_cor_traffic_units char(3) NOT NULL default 'Gb', os_cor_dbs smallint(6) NOT NULL default 0, os_cor_mailboxes smallint(6) NOT NULL default 0, os_cor_unique_ip tinyint(1) NOT NULL default 0, os_cor_shop_cart tinyint(1) NOT NULL default 0, os_cor_sec_cert tinyint(1) NOT NULL default 0, os_cor_site_pages tinyint(4) NOT NULL default 0, os_cor_comments text NOT NULL, os_cor_optfld_01 varchar(50) NOT NULL default '', os_cor_optfld_02 varchar(50) NOT NULL default '', os_cor_optfld_03 varchar(50) NOT NULL default '', os_cor_optfld_04 varchar(50) NOT NULL default '', os_cor_optfld_05 varchar(50) NOT NULL default '', PRIMARY KEY (os_s_id)) TYPE=MyISAM COMMENT='Site Orders Module Sessions Table';
CREATE TABLE %PREFIX%pages (id int(9) NOT NULL auto_increment, subject varchar(50) NOT NULL default '', topic_id int(11) NOT NULL default 1, cat_id int(11) NOT NULL default 1, time_stamp varchar(10) default NULL, pages_title varchar(50) default NULL, pages_code longtext NOT NULL, pages_block_it tinyint(1) NOT NULL default 0, pages_status tinyint(1) NOT NULL default 0, pages_admin tinyint(1) NOT NULL default 0, pages_link_menu tinyint(1) NOT NULL default 0, pages_link_prev int(11) NOT NULL default 0, pages_link_home int(11) NOT NULL default 0, pages_link_next int(11) NOT NULL default 0, PRIMARY KEY (id)) TYPE=MyISAM COMMENT='Site Pages Module Table' AUTO_INCREMENT=4;
INSERT INTO %PREFIX%pages (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `pages_title`, `pages_code`, `pages_block_it`, `pages_status`, `pages_admin`, `pages_link_menu`, `pages_link_prev`, `pages_link_home`, `pages_link_next`) VALUES (1, 'Example Page', 1, 1, '%TIMESTAMP%', 'Example Page', '<p align="center"><strong>Please note: </strong>This is a sample page.\r\n', 1, 1, 0, 0, 0, 0, 0);
INSERT INTO %PREFIX%pages (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `pages_title`, `pages_code`, `pages_block_it`, `pages_status`, `pages_admin`, `pages_link_menu`, `pages_link_prev`, `pages_link_home`, `pages_link_next`) VALUES (2, 'Backup Disallowed', 3, 1, '%TIMESTAMP%', 'Backup Disallowed', 'Your attempt to backup the database has been disallowed, sorry. Either you are not an admin, or you used a POST/GET request from outside this website.', 1, 0, 0, 0, 0, 0, 0);
INSERT INTO %PREFIX%pages (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `pages_title`, `pages_code`, `pages_block_it`, `pages_status`, `pages_admin`, `pages_link_menu`, `pages_link_prev`, `pages_link_home`, `pages_link_next`) VALUES (3, 'Backup Completed', 3, 1, '%TIMESTAMP%', 'Backup Completed', 'The MySQL database backup procedure has completed. Depending on the backup option you chose, you will now have one of the following:<ul>\r\n<li>A MySQL dump file of the database on your computer, or</li>\r\n<li>A MySQL dump of the database in a directory on your webserver, or</li>\r\n<li>An email message with a MySQL dump of the database attached.</li>\r\n</ul>', 1, 0, 0, 0, 0, 0, 0);
CREATE TABLE %PREFIX%parameters (parm_id int(11) NOT NULL auto_increment, parm_group varchar(10) NOT NULL default 'common', parm_group_sub varchar(10) NOT NULL default 'undefined', parm_type char(1) NOT NULL default 'S', parm_name varchar(50) NOT NULL default '', parm_desc varchar(50) NOT NULL default '', parm_value varchar(100) NOT NULL default '', parm_notes text NOT NULL, PRIMARY KEY (parm_id), UNIQUE KEY `parm_name` (`parm_name`)) TYPE=MyISAM COMMENT='Site Parameters Table';
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'B', 'HELPDESK_AUTO_IMPORT_ENABLE', 'Helpdesk: Auto-import enable', '1', 'If "Yes", helpdesk_auto.php will connect to a POP or IMAP box and attempt to create helpdesk tickets from any messages found.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_SERVER', 'Helpdesk: Auto-import server', 'mail.%DOMAINNAME%', 'Name of the email server to connect to for auto-importing helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_TYPE', 'Helpdesk: Auto-import protocol', ':143/imap/notls', 'Protocol and port to connect. "/imap:143" seems to work better than "/pop:110". You may also need to try /IMAP/:143/notls or /:110/POP/notls depending on your mailserver');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_USERID', 'Helpdesk: Auto-import mailbox', 'support@%DOMAINNAME%', 'The mailbox to connect to for helpdesk auto-import.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_PASSWORD', 'Helpdesk: Auto-import password', 'password', 'Password for the email box that will be checked automaticaly.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'I', 'HELPDESK_AUTO_IMPORT_DELETE_MESSAGES', 'Helpdesk: Auto-import delete', '1', 'Delete _these_ messages on the mail-server');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_CATEGORY', 'Helpdesk: Auto-import category', 'General', 'Default "category" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_PRIORITY', 'Helpdesk: Auto-import priority', 'Medium Priority', 'Default "priority" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_STATUS', 'Helpdesk: Auto-import status', 'Awaiting Support', 'Default "status" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_ACOPY_DELAY_ENABLE', 'Invoice Auto-Copy Delay Enable', '1', 'Determines if the auto-copy of recurring invoices is delayed until new invoice date is within days out setting.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'I', 'INVC_ACOPY_DAYS_OUT', 'Invoice Auto-Copy Days Out to Copy', '14', 'Determines number of days from current date to auto-copy a recurring invoice. Will auto-copy if the new invoice date falls within this date range.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_AUTO_UPDATE_ENABLE', 'Invoice Auto-Update of Status Enable', '1', 'Determines if the auto-update of invoice status function is enabled when triggered by cron job or manually by command summary actions menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_AUTO_COPY_ENABLE', 'Invoice Auto-Copy Recurring Enable', '1', 'Determines if the auto-copy of recurring invoices function is enabled when triggered by cron job or manually by command summary actions menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_AUTO_REMINDERS_ENABLE', 'Invoice Overdue- Autosend overdue reminders', '1', 'If "Yes", phpCOIN will auto-send the specified email message on the specified overdue day(s). If "No", you must manually remind your customers that they are overdue. You may setup as many event-dates and templates as you need.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_SOON_REMINDERS_ENABLE', 'Invoice Due- Autosend soon-due reminders', '1', 'If "Yes", phpCOIN will auto-send nag email message zero half way between the invoice issued and due dates. If "No", there will be NO reminders that an invoice will soon be due.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'helpdesk', 'B', 'HELPDESK_AUTO_VERBOSE', 'Helpdesk: Auto-import verbose', '1', 'If "Yes", phpCOIN will display the results of processing of each email message. If "No", phpCOIN will only display aggregate results.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'B', 'ORDER_AUTO_CREATE_INVOICE', 'Invoice: Auto-Create From Order', '1', '"Yes" will auto-create an invoice with the default terms, due dates, etc. everytime a product is ordered. "No" will NOT create the invoice.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'B', 'AUTO_INV_RECUR', 'Invoice: Auto-Recur From Order', '1', '"Yes" will set the invoice as recurring. "No" will set the invoice as NOT recurring (ie: one-time)');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'S', 'AUTO_INV_STATUS', 'Invoice: Default Status', 'due', 'Default status of invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'S', 'AUTO_INV_DELIVERY', 'Invoice: Default Delivery Method', 'email', 'Default delivery method for invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'I', 'AUTO_INVC_BILL_CYCLE', 'Invoice: Default Billing Cycle', '1', 'Default billing cycle for invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'orders', 'B', 'AUTO_INV_DELIVERED', 'Invoice: Flag as Delivered', '1', 'Should the invoice "delivered" flag be set to delivered?');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'package', 'B', 'AUTOCHECK_UPDATES', 'Automatically Check For Updates', '1', 'If enabled, phpCOIN will check for new versions and bug-fixes each time you click the [Admin] button. This parameter enables phpCOIN to advise you when a new version or bug-fix is available, and provides a direct link to the actual download.  This feature uses an RSS feed, and does NOT send any information whatsoever to phpCOIN.com');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'admin', 'I', '_MAX_MENU_BLK_POS', 'Menu Block Position List Max Select', '25', 'Determines the maximum number to appear in the menu block position field dropdown list.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'admin', 'I', '_MAX_MENU_ITM_NO', 'Menu Block Item Position List Max Select', '25', 'Determines the maximum number to appear in the menu block item position field dropdown list.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'admin', 'B', '_PARM_EDITOR_SHOW_NOTES', 'Parameter Editor Show Notes in Listing', '1', 'To enable the display of the parameter notes field in the main listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'admin', 'B', 'DisplayType', 'Admin Menu: Display as List', '0', 'Displays the Admin Menu as default "button" table or as new "list" format');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_MASTER_ENABLE', 'API Output Master Enable', '0', 'Determines if the API Output function triggers (all) are enabled.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_COR_PROC_ENABLE', 'API Output Enable: Order COR Proc', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_NEW_CLIENT_ENABLE', 'API Output Enable: Order New Client', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_NEW_DOMAIN_ENABLE', 'API Output Enable: Order New Domain', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_OUT_PROC_ENABLE', 'API Output Enable: Order Out Proc', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_RET_PROC_ENABLE', 'API Output Enable: Order Return Proc', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_CLIENT_NEW_ENABLE', 'API Output Enable: Client Created', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_CLIENT_DEL_ENABLE', 'API Output Enable: Client Deleted', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_DOMAIN_NEW_ENABLE', 'API Output Enable: Domain Created', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_DOMAIN_DEL_ENABLE', 'API Output Enable: Domain Deleted', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_NEW_ENABLE', 'API Output Enable: Order Created', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_ORDER_DEL_ENABLE', 'API Output Enable: Order Deleted', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_PRODUCT_NEW_ENABLE', 'API Output Enable: Product Created', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_PRODUCT_DEL_ENABLE', 'API Output Enable: Product Deleted', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_TRANS_NEW_ENABLE', 'API Output Enable: Trans Created', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'API', 'B', 'APIO_TRANS_DEL_ENABLE', 'API Output Enable: Trans Deleted', '0', 'Determines if the API Output function trigger is enabled for the indicated item.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'articles', 'I', 'IPP_ARTICLES', 'Listing Items Per Page for: Articles', '10', 'Determines the number of articles that are displayed  in listing form on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'articles', 'S', 'ARTICLES_DATE_DISPLAY_FORMAT', 'Articles Date/Time Display Format', '%A- %B %d, %Y @ %H:%M:%S %Z', 'Determines the display format for the Articles module date display. See http://www.php.net/manual/en/function.strftime.php for formatting options.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_SAVE_DIR', 'MySQL Backup- Save Directory', 'c:/php/temp', 'Directory on webserver to save mySQL dump file to when the "save to webserver" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_FROM_NAME', 'MySQL Backup- Email From Name', 'WebSite', 'The name of the person that the email is from when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_FROM_ADDRESS', 'MySQL Backup- Email From Address', 'webserver@%DOMAINNAME%', 'The email address of the person that the email is from when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_TO_NAME', 'MySQL Backup- Email To Name', 'Recipient Name', 'The name of the person that the email is to when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_TO_ADDRESS', 'MySQL Backup- Email To Address', 'support@%DOMAINNAME%', 'The email address of the person that the email is to when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_SUBJECT', 'MySQL Backup- Email Subject', 'phpCOIN Database Backup Attached', 'Subject line of email sent when "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_BODY', 'MySQL Backup- Email Body', 'A MySQL dump of your phpCOIN database is attached to this email.', 'The message body when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'backup', 'I', 'MYSQL_BACKUP_EMAIL_PRIORITY', 'MySQL Backup- Email Priority', '3', 'Priority of message when "email to me" backup option is chosen. 1 is "Urgent", 3 is "Normal".');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'BASE_CLIENT_ID', 'Client ID Base-Initial Value Minus 1', '1000', 'Determines the client id initial value for the first client entered in the system. Client ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'IPP_CLIENTS', 'Listing Items Per Page for: Clients', '10', 'Determines the number of clients that are displayed on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'IPL_CLIENTS_ACCOUNT', 'Listing Items Per List for: Client Account', '5', 'Determines the number of most recent items (orders, invoices, tickets) that are displayed on a clients account page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'S', 'CLIENT_DEF_STATUS_NEW', 'Client Default Status on Create', 'active', 'Determines the default client status used when order placed, new auto-created.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'B', 'CLIENT_EMAIL_CC_ENABLE', 'Client Email CC Admin Enable', '1', 'Determines if the site admin will receive a copy each time a request is made to email a client profile.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'B', 'Username_AlphaNum', 'Allow Only AlphaNumeric UserName', '0', 'Determines if the username must contain only letters and numbers, or if special characters such as pound and underscore are allowed');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'CLIENT_MAX_LEN_UNAME', 'Client Max. Characters for User Name', '16', 'Determines the maximum number of characters permitted in username form fields.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'CLIENT_MAX_LEN_PWORD', 'Client Max. Characters for Password', '16', 'Determines the maximum number of characters permitted in password form fields.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'CLIENT_MIN_LEN_PWORD', 'Client Min. Characters for Password', '8', 'Determines the minimum number of characters permitted in password form fields.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'CLIENT_VIEW_PAGE_UPON_LOGIN', 'Client Default Page View Upon Login', '1', 'The page to show the client when they first log in.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'I', 'CLIENT_LIST_DISPLAY', 'Optional Data Display for Listing', '1', 'Select the two-out-of-three columns that you wish displayed when viewing a list of clients.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'contacts', 'I', 'MC_ID_BILLING', 'Mail Contact ID For Billing', '1', 'Determines the mail contact id to be used when code requires an email address for: Billing');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'contacts', 'I', 'MC_ID_ORDERS', 'Mail Contact ID For Orders', '2', 'Determines the mail contact id to be used when code requires an email address for: Orders');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'contacts', 'I', 'MC_ID_SUPPORT', 'Mail Contact ID For Support', '3', 'Determines the mail contact id to be used when code requires an email address for: Support');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'contacts', 'I', 'MC_ID_WEBMASTER', 'Mail Contact ID For Webmaster', '4', 'Determines the mail contact id to be used when code requires an email address for: Webmaster');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'I', 'IPP_DOMAINS', 'Listing Items Per Page for: Domains', '10', 'Determines the number of domains that are displayed in listing form on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'I', 'DOM_DEFAULT_SERVER', 'Domain Account Default Server ID', '1', 'Determines the default server id that is inserted when a domain is created.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'S', 'DOM_DEFAULT_PATH', 'Domain Account Default Path', '/home/httpd/vhosts/domainname/httpdocs', 'Note: place "domainname" in path to have it replaced by domain name, or "username" in path to have it replaced by username on entry create.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'DOM_EMAIL_CC_ENABLE', 'Domain Email CC Admin Enable', '1', 'Determines if the site admin will receive a copy each time a request is made to email a domain activation email.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'DOM_FORCE_CHECK_TRUE', 'Domain Name Validation Force True', '0', 'Determines if the domain validation logic always returns true. Only for those who not want to validate input domain names.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'S', 'DOM_DEFAULT_IP', 'Domain Account Default IP Address', '000.000.000.000', 'Determines the default domain IP address that is inserted when a domain account is created.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'S', 'DOM_DEFAULT_USERNAME', 'Domain CP/FTP Default User Name', 'username', 'Determines the default CP/FTP User Name inserted when a domain account is created. Choose "username" to insert client user name, or "domain" to insert the domain name.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'S', 'DOM_DEFAULT_CP_URL', 'Domain Default Control Panel URL', '', 'Determines the URL (fully qualified) that will be used for the control panel link shown in domain listings.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'DOM_CP_URL_LINK_ENABLE', 'Domain Listing CP Link Enable', '1', 'Determines if the control panel link will be shown in domain listings.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'MATCH_CP_LOGIN_TO_ACCOUNT', 'Domain CP/FTP Match FTP Password To phpCOIN', '0', 'If "No", a random password for FTP will be generated by phpCOIN. If "Yes", the FTP password created by phpCOIN will match the username and password entered by the client for accessing phpCOIN. This means that you will know the u/p for account creation with cPanel, etc., but it is a security risk because the info is stored in the clear in the database');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'SHOW_PASSWORDS_TO_CLIENTS', 'Domain CP/FTP Show Passwords To Clients', '1', 'IF "Yes", clients can see their plaintext passwords for FTP and Control Panel access when viewing domain info. If "No", only admins can see the passwords.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'domains', 'B', 'DOMAINS_ENABLE', 'Domains Enable (Visible)', '1', 'Determines if the Domains module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'I', 'IPP_HELPDESK', 'Listing Items Per Page for: HelpDesk', '10', 'Determines the number of helpdesk tickets that are displayed  in listing form on a page.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'I', 'BASE_HELPDESK_ID', 'HelpDesk TT ID Base-Initial Value Minus 1', '1000', 'Determines the helpdesk ticket id initial value for the first helpdesk ticket entered in the system. Helpdesk Ticket ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_ENABLE', 'Helpdesk Enable (Visible)', '1', 'Determines if the HelpDesk module is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'S', 'HELPDESK_ALERT_EMAIL_ADDRESS', 'HelpDesk TT Alert Email Address', 'webmaster@%DOMAINNAME%', 'Determines the email (pager email) address the Alert Email is sent to. Does not effect normal support email received.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_ALERT_EMAIL_ENABLE', 'Helpdesk TT Alert Email Enable', '1', 'Determines if an Alert Email is also sent when a new ticket is created. In addition to normal email to support.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_ADMIN_REVEAL_ENABLE', 'Helpdesk Admin Reveal Identity Enable', '0', 'The setting is to enable the Admin responding to HelpDesk items to be identified by Admin information in listing and emails.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_MSG_CC_CLIENT_ENABLE', 'Helpdesk Message Email CC Client Enable', '0', 'The setting is to email CC to the client when they submit helpdesk messages. Set to no, only the support receives the message.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_REPLY_EMAIL_SET_LIMIT', 'Helpdesk Reply Email Limit Messages Sent', '0', 'The setting will limit the number of helpdesk messages included in the reply notice email, to the _LIMIT parameter most recent.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'I', 'HELPDESK_REPLY_EMAIL_LIMIT', 'Helpdesk Reply Email Messages Limit Setting', '2', 'The setting is the number of most recent messages to include in the reply notice email.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_SHOW_CLIENT_NAME', 'Helpdesk Admin List Show Client Name', '1', 'The setting is to enable the Client column in the Admin Helpdesk listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'helpdesk', 'B', 'HELPDESK_ADMIN_CAN_ADD', 'Admin Can Enter New Support Tickets', '1', 'If "Yes", an administrator can enter a new support ticket on behalf of a client. If "No", only a client can enter a new support ticket.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'I', 'IPP_INVOICES', 'Listing Items Per Page for: Invoices', '10', 'Determines the number of invoices that are displayed  in listing form on a page.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'I', 'BASE_INVOICE_ID', 'Invoice ID Base-Initial Value Minus 1', '1000', 'Determines the invoice id initial value for the first invoice entered in the system. Invoice ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_AUTO_EMAIL_ENABLE', 'Invoice Auto-Email to Clients Enable', '1', 'Determines if the auto-email of due invoices function is enabled when triggered by cron job or manually by command summary actions menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_AUTO_EMAIL_CC_ENABLE', 'Invoice Auto-Email CC Admin Enable', '1', 'Determines if the site admin will receive a copy each time a the auto-email code sends an invoice.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'S', 'INVC_DEL_MTHD_DEFAULT', 'Invoice Delivery Method Default Value', 'email', 'Determines the default invoice delivery method presented on invoice create.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'I', 'INVC_DUE_DAYS_OFFSET', 'Invoice Due Date Offset from Create in Days', '14', 'Determines the number of days to add to current date and set the due date to when creating a new invoice.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_EMAIL_CC_ENABLE', 'Invoice Email CC Admin Enable', '1', 'Determines if the site admin will receive a copy each time a request is made to email an invoice.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_TAX_01_ENABLE', 'Invoice Tax 01 Enable', '1', 'Determines if invoice tax 01 is enabled for display and calculation.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_TAX_02_ENABLE', 'Invoice Tax 02 Enable', '1', 'Determines if invoice tax 02 is enabled for display and calculation.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_TERMS_INSERT_DEF', 'Invoice Terms- Insert Default on New', '1', 'Determines if, when terms enabled, the default terms value is inserted on new invoice create (if left empty on save).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_TERMS_ENABLE', 'Invoice Terms- Enable Display', '1', 'Determines if the invoice terms field is displayed on invoice views.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_SHOW_CLIENT_PENDING', 'Invoice Show Client Pending Invoices', '1', 'Determines if the client will see invoices that are set to pending status.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_SPLIT_TRANS_LIST_ENABLE', 'Invoice Transaction Listing Split Enable', '1', 'Determines if the invoice transaction listing is split to list charges on top, and then credits below (in seperate list).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_TAX_BY_ITEM', 'Invoice Tax By Item Enable', '1', 'Determines if the taxes are applied at the items level (each item), or just on the total of items.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'S', 'INVC_TAX_01_LABEL', 'Invoice Tax 01 Text Label', '13% HST:', 'Determines the text label displayed throughout the package in place of "Tax 01".');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'R', 'INVC_TAX_01_DEF_VAL', 'Invoice Tax 01 Rate Default Value', '13.00', 'Determines the default tax rate percentage value inserted for this tax. Example 1.00 equates to 1 percent.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'S', 'INVC_TAX_02_LABEL', 'Invoice Tax 02 Text Label', '5% PST:', 'Determines the text label displayed throughout the package in place of "Tax 01".');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'R', 'INVC_TAX_02_DEF_VAL', 'Invoice Tax 02 Rate Default Value', '5.00', 'Determines the default tax rate percentage value inserted for this tax. Example 1.00 equates to 1 percent.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'I', 'INVC_VIEW_SHOW_TRANS', 'Invoice View Show Transactions Enable', '1', 'Determines if the invoice transactions listing is displayed on lower portion of invoice view. 0: No, 1: On-Screen Only, 2: Printed Only, 3: Onscreen and Printed ');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'PRICES_INCLUDE_TAXES', 'Invoice Taxes Are Included In Price', '0', 'If "No", phpCOIN will add applicable taxes to items on invoices. If "Yes", phpCOIN assumes that the prices include tax. In that event, taxes will be removed from the items and then recalculated, so the invoice can show the amount of taxes included in the prices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'SINGLE_LINE_EMAIL_INVOICE_ITEMS', 'Single-line per item for email', '1', 'Set each item on an emailed invoice to be single-line like a paper invoice, or use default multi-line layout.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVOICES_ENABLE', 'Invoices Enable (Visible)', '1', 'Determines if the Invoices module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'invoices', 'B', 'INVC_SHOW_LAST_NAG', 'Invoice- Show Last Nag', '1', 'Determines if an additional info-box containing the last nag email sent will be displayed as part of the invoice.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'layout', 'S', '_PKG_FOOTER_LINE_01', 'Site Footer Block Line 01 Text', 'Copyright %DOMAINNAME% 2003-2007, all rights reserved', 'Determines the line 01 text that will be displayed in footer of the page output.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'layout', 'S', '_PKG_FOOTER_LINE_02', 'Site Footer Block Line 02 Text', '', 'Determines the line 02 text that will be displayed in footer of the page output.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', '_PKG_EMAIL_OUT_DISABLE', 'Package Email Out Disable', '0', 'Determines if the main email functions are disabled from sending.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', 'MAIL_USE_CUSTOM_SUBJECT', 'Email Contact Client: Use Custom Subject', '1', '"No" will use the default subject line of "sitename- Client Contact Message" on emails sent using the [eMail Client] form. "Yes" will use the subject that you entered on the form instead.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', '_PKG_SAFE_EMAIL_ADDRESS', 'Safe Email Address', '0', 'If "No", emails sent from phpCOIN use the "Name <name@address>" format. Some mail servers have a problem with this, so setting this value to "Yes" means that emails will be sent as only <name@address> which every mailserver will accept.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', 'EMAIL_AS_HTML', 'Email: Enable HTML email', '1', 'Enables sending emails as html email with attachments, or as plain ascii text');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', 'ENABLE_QUICK_EDIT', 'Enable Quick-Edit Icons', '1', 'Enables a quick-access icon for editing parameters and page text, rather than forcing admin to goto Admin and select proper options');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'IPP_ORDERS', 'Listing Items Per Page for: Orders', '10', 'Determines the number of orders that are displayed in listing form on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'BASE_ORDER_ID', 'Order ID Base-Initial Value Minus 1', '1000', 'Determines the order id initial value for the first order entered in the system. Order ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ENABLE_EMAIL_ORDER_OUT', 'Email to Admin on Order Out Enable', '1', 'Determines if an email is sent to admin when client is showed the order paylinks (order inserted into system).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ENABLE_EMAIL_ORDER_RET', 'Email to Admin on Order Return Enable', '1', 'Determines if an email is sent to admin when client is returned to site from billing vendor.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_POLICY_BTTN_AUP', 'Order Policy Button Show: AUP', '1', 'Determines if order policy button for Acceptable Use Policy is shown on place order screens.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_POLICY_BTTN_BC', 'Order Policy Button Show: BC', '1', 'Determines if order policy button for Banned Code is shown on place order screens.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_POLICY_BTTN_PP', 'Order Policy Button Show: PP', '1', 'Determines if order policy button for Privacy Policy is shown on place order screens.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_POLICY_BTTN_TOS', 'Order Policy Button Show: TOS', '1', 'Determines if order policy button for Terms Of Service is shown on place order screens.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDER_POLICY_SI_ID_AUP', 'Order Policy SiteInfo ID for: AUP', '6', 'Determines the siteinfo page id for the Acceptable Use Policy button link.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDER_POLICY_SI_ID_BC', 'Order Policy SiteInfo ID for: BC', '8', 'Determines the siteinfo page id for the Banned Code Policy button link.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDER_POLICY_SI_ID_PP', 'Order Policy SiteInfo ID for: PP', '5', 'Determines the siteinfo page id for the Privacy Policy button link.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDER_POLICY_SI_ID_TOS', 'Order Policy SiteInfo ID for: TOS', '7', 'Determines the siteinfo page id for the Terms Of Service button link.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_EMAIL_CC_ENABLE', 'Order Email CC Admin Enable', '1', 'Determines if the site admin will receive a copy each time a request is made to email a order.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_ACK_EMAIL_ENABLE', 'Orders Ack Email To Client Enable', '1', 'Determines if an acknowledgment email will be sent to client on new order.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_ACK_EMAIL_ONRET', 'Orders Ack Email To Client On Return', '1', 'Determines if an acknowledgment email will be sent on return from vendor, instead of upon paylink display.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_ENABLE', 'Orders Enable (Visible)', '1', 'Determines if the Orders module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_AUP_ENABLE', 'Orders Req. Acceptable Use Policy (AUP) Enable', '1', 'Determines if the agree to the Acceptable Use Policy button and requirement is visible during order placement.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_COR_ENABLE', 'Orders Custom Order Request (COR) Enable', '1', 'Determines if the Custom Order Request (COR) button / link is visible during the order placement.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_TOS_ENABLE', 'Orders Req. Terms Of Service (TOS) Enable', '1', 'Determines if the agree to the Terms Of Service button and requirement is visible during order placement.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'S', 'ORDERS_DEF_STATUS_NEW', 'Orders Default Status on Create', 'pending', 'Determines the default order status used when order placed, new auto-created.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_FIELD_ENABLE_COR', 'Orders Form Field Enable Settings- COR', '65504', 'Determines which fields are enabled (visible) on the orders COR form.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_FIELD_ENABLE_ORD', 'Orders Form Field Enable Settings- Order', '65504', 'Determines which fields are enabled (visible) on the orders order form. This also effects client editing forms.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_FIELD_REQUIRE_COR', 'Orders Form Field Require Settings- COR', '49184', 'Determines which fields are required (visible) on the orders COR form.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_FIELD_REQUIRE_ORD', 'Orders Form Field Require Settings- Order', '24448', 'Determines which fields are required (visible) on the orders order form. This also effects client editing forms.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_LIST_SHOW_PROD_DESC', 'Orders Listing Show Prod. Description', '1', 'Determines if the Product description will be displayed on Orders Listings instead of the default Vendor / Product Name columns.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_PROD_DISPLAY_SEQUENCE', 'Orders- Products Display Sequence', 1, 'What to display on the Products List shown to clients when ordering.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_PROD_LIST_SORT_ORDER', 'Orders Product List Primary Sort Field', '1', 'Determines which field will be the ascending sort order for the order screen products list.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'DEFAULT_PAYMENT_METHOD', 'Default Payment Method On Order Form', '0', 'The billing method to use on a new order, or let client select payment method from a drop-down list of vendors. If you specify a vendor here, all modules that normally display the billing vendor will no longer do so.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'R', 'ORDER_SETUP_FEE', 'Add $xxx.yy to Order As Order Setup Fee', '0', 'Any amount here other than zero will be added to the price of the product ordered as a setup fee, and the words " (plus setup fee)" will be appended to the item description on the order.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'I', 'ORDERS_PROD_LIST_SIZE', 'Product list type and size', '1', 'If 0, products will be displayed as a radio list on the order form. Any non-zero value will use a select-list with that many rows visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_ITEMS_SUB-LIST', 'Group products with heading', '1', 'If items are displayed on order form by radio list, setting this ON will "group" 	the products by the first word in the product display, with that word also used as a group title. This means you can group products by name, description or price.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_EDIT_CLIENT', 'Allow editing client info on re-order', '0', 'YES will allow an existing client to edit their contact info when placing a new order. NO will display their contact info without allowing editing');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDER_SHOW_IP', 'Whether or not to show user IP address on order form to deter fraud', '1', 'YES will display the users IP address and a warning when placing a new order. NO will display nothing');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_CURRENCY_PREFIX', 'Currency Prefix String (ex. $)', '$', 'Determines the currency notation prefix, placed in front of currency amounts (where formatted to display).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_CURRENCY_SUFFIX', 'Currency Suffix String (ex. USD)', '(USD)', 'Determines the currency notation suffix, placed following currency amounts (where formatted to display).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_DB_PKG_LANG', 'Package Language (database setting)', 'lang_english', 'Determines which language files to load. The language file directory and files MUST exist prior to selection. Maybe be overridden by config.php setting.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_DB_PKG_LOCALE', 'Package Locale Setting (datetime display)', 'en_EN', 'Some examples:\r\nBulgaria - bg_BG\r\nEnglish  - en_EN (or English)\r\nFrench   - fr_FR\r\nGerman  - German\r\nSwedish  - sv_SE\r\nSpanish  - Spanish\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_DB_PKG_THEME', 'Package Theme (database setting)', 'earthtone', 'Determines which theme files to load. The theme file directory and files MUST exist prior to selection. Maybe be overridden by config.php setting.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'I', '_NUMBER_FORMAT_ID', 'Number Format (see notes)', '3', 'Example number 1234.56\r\nValue = 1	Output: 1234\r\nValue = 2	Output: 1234.56\r\nValue = 3	Output: 1,234.56\r\nValue = 4	Output: 1 234,56\r\nValue = 5	Output: 1.234,56\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_NAME_SHORT', 'Site Name (short)', '%DOMAINNAME%', 'For display of site name (short version). This variable is used extensively in emails, and various pages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_NAME_LONG', 'Site Name (long)', '%DOMAINNAME% WebServices', 'Site long name for display, emails, etc. Basically longer version of the site short name.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_EMAIL_MAIL', 'Package Email (default)', 'support@%DOMAINNAME%', 'Package last resort email address when it cannot locate a mail contacts entry.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_TOP_GREETING', 'Site Top Block Greeting Text', 'Welcome To %DOMAINNAME% WebServices', 'The Site Top Block (header) greeting text displayed if logo is not enabled.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'I', '_PKG_DATE_SERVER_OFFSET', 'Date display server offset in hours (global)', '0', 'Determines any hour offset from server time for the timestamps recorded / displayed. Can be negative.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_DATE_FORMAT_SHORT_DT', 'Date Display Format for: Short Date (numerical)', 'Y-m-d', 'Determines the display format for the short datetime, not locale setting dependent. See http://www.php.net/manual/en/function.date.php for formatting options.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_DATE_FORMAT_SHORT_DTTM', 'Date Display Format for: Short DateTime (numerical', 'Y-m-d H:i:s', 'Determines the display format for the short datetime, not locale setting dependent. See http://www.php.net/manual/en/function.date.php for formatting options.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_DATE_FORMAT_HEADER', 'Date Display Format for: Header Row', '%A- %B %d, %Y', 'Determines the display format for the header block date display. See http://www.php.net/manual/en/function.strftime.php for formatting options.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'S', '_PKG_DATE_FORMAT_PRINT', 'Date Display Format for: Printing (includes time)', '%A- %B %d, %Y @ %H:%M:%S %Z', 'Determines the display format for the footer printed items  date display. See http://www.php.net/manual/en/function.strftime.php for formatting options.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'B', '_PKG_ENABLE_IP_BAN', 'Package Banned IP Feature Enable', '1', 'Package Banned IP Feature enables admin to create a list of banned IP addresses that can not view the site. Banned IPs are redirected to error message.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'B', '_PKG_ENABLE_EMAIL_ARCHIVE', 'Package Email Archive Enable', '1', 'Package Email Archive Enable set to YES will archive ALL emails sent out of the package.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'R', 'PAYLINK_EXCHANGE_RATE', 'Exchange Rate For PayLinks', '0', 'If you show your prices in one curency and collect payment in another, enter the exchange rate here. If you do not use different currencies, leave this as either 1 or 0');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'package', 'I', 'USE_LOGIN_MENUBOX', 'Use Login Menu Box', '1', 'If "Left Column", a login/logoff box will be displayed in the left column before any menus and the logon/logoff button in the header will be disabled. If "Right Column", a login/logoff box will be displayed in the right column before any menus and the logon/logoff button in the header will be disabled. If "None", phpCOIN defaults to normal operation. Make sure that if "Yes", then Admin -> Parameters -> Themes -> Disable Menu Columns (Left / Right) is also set to "No"');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'pages', 'I', 'IPP_PAGES', 'Listing Items Per Page for: Pages', '15', 'Determines the number of pages that are displayed  in listing form on a page.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'I', 'CC_DOMAIN_EXP_IN_DAYS', 'Summary- Domains Expiring In Days', '30', 'The setting determines the number of days from current to show as expiring domains in summary listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'CC_DOMAIN_EXP_LIST_ENABLE', 'Summary- Domains Expiring List Enable', '1', 'The setting enables the display of the domains expiring list in summary listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'CC_DOMAIN_EXP_LIST_INCL_EXPRD', 'Summary- Domains Expiring List Include Expired', '1', 'The setting enables the display of the domains expiring list in summary listing to also include expired domains.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'I', 'CC_SACC_EXP_IN_DAYS', 'Summary- Server Accounts Expiring In Days', '30', 'The setting determines the number of days from current to show as expiring server accounts in summary listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'CC_SACC_EXP_LIST_ENABLE', 'Summary- Server Accounts Expiring List Enable', '1', 'The setting enables the display of the server account expiring list in summary listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'CC_SACC_EXP_LIST_INCL_EXPRD', 'Summary- Server Accounts Expiring List Include Exp', '1', 'The setting enables the display of the server account expiring list in summary listing to also include expired server accounts.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'CC_SERVER_LIST_ENABLE', 'Summary- Servers List Enable', '1', 'The setting enables the display of the servers list in summary listing.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'PRODUCT_SUMMARY_ENABLE', 'Summary- Display Active Products', '1', '"Yes" will display a summary of all products that are on an active order. "No" will not display. If "Orders Listing Show Prod. Description" in the "orders" section is set to "Yes", then the description will show on the display, otherwise the product name will be shown.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'SUMMARY_INVOICES_BY_TYPE', 'Summary: Display Invoices By Billing Cycle', '1', 'If "Yes", invoices will be listed in columnar format, with the amounts broken out by status and billing cycle.  If "No", the default is to lump all billing cycles into one column.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'SUMMARY_INVOICES_BY_PRODUCT', 'Summary: Display products that have been invoiced', '1', 'If "Yes", phpCOIN will display a table with the number of times each invoiced product appears on an invoice, as well as the total value.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'S', 'SUMMARY_INVOICES_BY_PRODUCT_IGNORE', 'Summary: Ignore these invoiced poducts', '', 'A pipe-seperated list of item codes on invoices that should be ignored when building the invoiced products summary.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'R', 'DOMAIN_SETUP_FEE', 'Add $xxx.yy to Order As Domain Setup Fee', '0', 'Any amount here other than zero will be added to the price of the product ordered as a domain setup fee, and the words " (plus setup fee)" will be appended to the item description on the order IF the mrwhois module "Order" link was clicked.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'S', 'WHOIS_AFFILIATE_LINK', 'Registrar Affiliate Link', 'http://www.123-reg.co.uk/affiliate.cgi?id=AF8763', 'If you are an affiliate of a domain registrar and wish to use an affiliate link to register domains, enter the URL of the link here.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'B', 'WHOIS_EXT_LIST', 'Show Extensions DropDown List', '1', '"Yes" will show allowable domain extensions as a drop-down list. "No" will show the list as radio buttons.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'B', 'WHOIS_DETAILS_NEW', 'Show Domain Details In New Window', '1', '"Yes" will show details of registered domain in new "popup" window, "No" will use current window.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'B', 'WHOIS_INSTRUCTIONS_SHORT', 'Show Short Instructions', '0', '"Yes" will show abbreviated domain selection instructions to surfers, "No" will show the long instructions.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'B', 'WHOIS_ENABLED', 'WHOIS Enable (Visible)', '1', 'Determines if the WHOIS module is visible to the clients.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'whois', 'I', 'WHOIS_LINK', 'Domain Registration Operation', '1', '0= Do NOT add an "Order" or "Register" link.\r\n1= Add "Order" link and go to "orders" page, passing in domain name and setting "New Domain" to "Yes".\r\n2= Add "Register" link, going to your affiliiate link to register the domain. This option will open a new browser window to the registrar, and the original browser window will remain on this page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_01', 'Header Menu Button 01: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_02', 'Header Menu Button 02: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_03', 'Header Menu Button 03: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_04', 'Header Menu Button 04: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_05', 'Header Menu Button 05: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_06', 'Header Menu Button 06: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_07', 'Header Menu Button 07: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_08', 'Header Menu Button 08: Enable', '0', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_HDR_MENU_BTTN_09', 'Header Menu Button 09: Enable', '1', 'Determines whether the button appears in the top menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_01', 'Header Menu Button 01: Link', 'index.php', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_02', 'Header Menu Button 02: Link', 'mod.php?mod=siteinfo&id=4', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_03', 'Header Menu Button 03: Link', 'mod.php?mod=articles', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_04', 'Header Menu Button 04: Link', 'mod.php?mod=mail&mode=contact', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_05', 'Header Menu Button 05: Link', 'mod.php?mod=faq', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_06', 'Header Menu Button 06: Link', 'mod.php?mod=helpdesk&mode=new', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_07', 'Header Menu Button 07: Link', 'mod.php?mod=search', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_08', 'Header Menu Button 08: Link', 'index.php', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_LINK_09', 'Header Menu Button 09: Link', 'mod.php?mod=orders', 'Determines link (URL) for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_01', 'Header Menu Button 01: Image', '_IMG_MT_HOME_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_02', 'Header Menu Button 02: Image', '_IMG_MT_ABOUT_US_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_03', 'Header Menu Button 03: Image', '_IMG_MT_ARTICLES_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_04', 'Header Menu Button 04: Image', '_IMG_MT_CONTACT_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_05', 'Header Menu Button 05: Image', '_IMG_MT_FAQ_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_06', 'Header Menu Button 06: Image', '_IMG_MT_HELPDESK_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_07', 'Header Menu Button 07: Image', '_IMG_MT_SEARCH_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_08', 'Header Menu Button 08: Image', '_IMG_MT_SERVICES_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_HDR_MENU_BTTN_IMG_09', 'Header Menu Button 09: Image', '_IMG_MT_PLACE_ORDER_B', 'Determines image for the corresponding button in main menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_02', 'User Menu Button 02: Enable', '1', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_03', 'User Menu Button 03: Enable', '1', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_04', 'User Menu Button 04: Enable', '1', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_05', 'User Menu Button 05: Enable', '1', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_06', 'User Menu Button 06: Enable', '1', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_07', 'User Menu Button 07: Enable', '0', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'B', '_USR_MENU_BTTN_08', 'User Menu Button 08: Enable', '0', 'Determines whether the button appears in the user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_02', 'User Menu Button 02: Link', 'mod.php?mod=domains', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_03', 'User Menu Button 03: Link', 'mod.php?mod=orders&mode=view', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_04', 'User Menu Button 04: Link', 'mod.php?mod=invoices', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_05', 'User Menu Button 05: Link', 'mod.php?mod=helpdesk&mode=list', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_06', 'User Menu Button 06: Link', 'mod.php?mod=cc', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_07', 'User Menu Button 07: Link', 'index.php', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_LINK_08', 'User Menu Button 08: Link', 'index.php', 'Determines link (URL) for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_02', 'User Menu Button 02: Image', '_IMG_MU_DOMAINS_B', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_03', 'User Menu Button 03: Image', '_IMG_MU_ORDERS_B', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_04', 'User Menu Button 04: Image', '_IMG_MU_INVOICES_B', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_05', 'User Menu Button 05: Image', '_IMG_MU_HELPDESK_B', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_06', 'User Menu Button 06: Image', '_IMG_MU_SUMMARY_B', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_07', 'User Menu Button 07: Image', 'undefined', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'buttons', 'S', '_USR_MENU_BTTN_IMG_08', 'User Menu Button 08: Image', 'undefined', 'Determines image for the corresponding button in user menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_DISABLE_MENU_COLS', 'Disable Menu Columns (Left / Right)', '0', 'Determines if the page left / right menu columns are hidden.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_DISABLE_HEADER_BLK', 'Disable Header (top) Block', '0', 'Determines if the page header row is hidden.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_DISABLE_FOOTER_BLK', 'Disable Footer (bottom) Block', '0', 'Determines if the page footer row is hidden.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_ENABLE_ADMIN_LOGIN_LINK', 'Admin Login Link Button Enable', '1', 'Determines if the "Admin" login button link is displayed on the client login screen.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_ENABLE_BTN_MOUSEOVER', 'Enable- Form Button Mouseover', '1', 'Enables the mouseover action on all form buttons throughout the package.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_ENABLE_MENU_USER_HDR', 'Enable- Menu User in Header Block', '0', 'Determines if the logged in user / admin menu is visible as a line directly below the main header menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_ENABLE_MENU_USER_HROW', 'Enable- Menu User in Header Row', '1', 'Determines if the logged in user / admin menu is visible as an additional row below the header.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_ENABLE_MENU_USER_FROW', 'Enable- Menu User in Footer Row', '0', 'Determines if the logged in user / admin menu is visible as an additional row above the footer.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_PAGE_HEADER_DATE', 'Site- Page Header Show Date', '1', 'Determines whether the date is displayed in the page header block.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_PAGE_HEADER_LOGO', 'Site- Page Header Show Logo', '1', 'Determines whether the site logo, or greeting text is displayed in the page header block.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'S', '_PAGE_HEADER_LOGO_FILE', 'Site- Page Logo Filename', 'logo_phpcoin.gif', 'Logo filename that is located in each theme /coin_images directory.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_PAGE_HEADER_CLEAR', 'Site- Page Header Make Clear', '0', 'Determines if the site header row is colored (styles) or clear (underlying color).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_PAGE_FOOTER_CLEAR', 'Site- Page Footer Make Clear', '1', 'Determines if the site footer row is colored (styles) or clear (underlying color).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'B', '_PKG_WRAPPER_ENABLE', 'Enable- Package Wrapper', '0', 'Package Wrapper Feature enables "wrapper" code around the phpCOIN package.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'S', '_WIDTH_OUTER_TABLE', 'Percent / Pixel (include % or px) of outmost table', '75%', 'Determines the pixel width of the package outermost table. Must be include either percent or pixel.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'I', '_WIDTH_COL_BLOCK', 'Percentage Width Of Menu left / right columns', '15', 'Determines the percentage of total width for each left / right menu column.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'I', '_WIDTH_MENU_BLOCK', 'Pixel Width Of Menu Block', '150', 'Determines the pixel width setting for a right / left column menu block.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'S', '_WIDTH_CONTENT_AREA', 'Percentage width of Content Area Tables', '100%', 'Determines the percentage width of the center content area that non modules output will consume.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'S', '_WIDTH_MODULE_AREA', 'Percentage Width Of Module Content', '100%', 'Determines the percentage width of the center content area that modules output will consume.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('theme', 'layout', 'I', '_WIDTH_PRINT_AREA', 'Pixel width of Print Tables', '700', 'Determines the pixel width of the package outer most table when being printed.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_01_NAME', 'Company Info 01: Name', 'A phpCOIN User', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_02_ADDR_01', 'Company Info 02: Address Line 01', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_03_ADDR_02', 'Company Info 03: Address Line 02', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_04_CITY', 'Company Info 04: City', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_05_STATE_PROV', 'Company Info 05: State/Prov', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_06_POSTAL_CODE', 'Company Info 06: Postal Code', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_07_COUNTRY', 'Company Info 07: Country', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_08_PHONE', 'Company Info 08: Phone No.', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_09_FAX', 'Company Info 09: FAX', '', 'Global scope variable, currently used in invoices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_10_TAXNO', 'Company Info 10: Tax Number', '', 'If you charge taxes and require that your tax registration number appear on invoices, etc., enter it here');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_11_TOLL_FREE', 'Company Info 11: Toll Free Number', '', 'Global scope variable, currently used in footer.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'S', 'CO_INFO_12_TAGLINE', 'Company Info 12: TagLine', 'A Clever TagLine Here', 'Text of a "tagline" that will appear on invoices, and in the site footer');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'B', 'DISPLAY_ON_CONTACT_FORM', 'Display On Contact Form', '1', 'If "Yes", the Company Information in this section will be displayed on the "Contact Us" form,as well as used on invoices. If "No", the "Contact Us" form will be an email-only-form.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('user', 'package', 'B', 'DISPLAY_ON_FOOTER', 'Display On Output Footer', '1', 'If "Yes", the Company Information in this section will be displayed in the footer of every page output by phpCOIN.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'downloads', 'B', 'LIMIT_DOWNLOADS_TO_LOGGED_IN', 'Downloads for logged-in users only', '0', 'If "Yes", a user must be logged-in in order to access the downloads page. If "No", anyone can access the downloads page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'downloads', 'B', 'HIDE_NOAVAILS', 'Show Available Downloads Only', '1', 'Whether phpCOIN will display all downloads in the database, or only those marked "available"');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'downloads', 'S', 'DLOAD_URL', 'Downloads Root URL', 'http://%DOMAIN%/coin_downloads/', 'Root URL where downloads are located. The http:// prefix and the trailing slash can be eliminated ~ phpCOIN will auto-append them if necessary.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','I','IPN_NUM_DISPLAY','IPN: Default number of items to display','25','Default number of items to display in IPN Log');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','B','IPN_SEND_TRANS_ACK','IPN: Send transaction ack email','1','Should the mod send a trans ack email when payment is recieved?');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','B','IPN_PROCESS_INCOMING','IPN: Process Incoming Data','1','If we accept data, do we want to process it also?');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','S','PAYPAL_RECEIVER_EMAIL','Paypal: Paypal EMail Address','payment@mividdesigns.com','This email needs to match your Primary PayPal email listed.  You can have multiple email addresses here sperated by spaces.\r\nEx:\r\n\r\njon@paypal.com john@paypal.com');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','B','IPN_SEARCH_NAME','Select invoice by name','1','This determines if the first and last name from the sender can also be used to determine the invoice if the email address cannot be used.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','B','IPN_ACCEPT_INCOMING','IPN: Accept IPN data','1','Should phpCOIN accept incoming IPN data and try to apply an invoice payment?  Or ignore it?  (Essentially the on/off switch).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','I','IPN_INVOICE_FIND_METHOD','IPN: Invoice Find Method','4','If no invoice number is sent with a Paypal transaciton, it searches by email address.  This is the method in which it applys the payment.\r\n0 - Highest invoice number, regardless of status\r\n1 - Highest invoice number that does not have status PAID\r\n2 - Highest invoice number that does not have status PAID, if none found, then return highest invoice num\r\n3 - Lowest invoice number that does not have status PAID\r\n4 - Lowest invoice number that does not have status PAID, IF none found, then return highest invoice number\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','B','IPN_ALLOW_RESUBMIT','Allow ipn transactions to be resubmitted','1','This will allow you to simulate the transaction being run again.  Doing this will NOT reverse any payments posted, status changes, etc.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','B','IPN_ALLOW_DELETE','Allow ipn transactions to be deleted','1','Allow IPN transactions to be deleted from the LOG');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation','ipn','B','IPN_REQUIRE_AMOUNT_MATCH','IPN: Require receiving amount to match invoice','0','If this is yes, the amount recieved must match the invoice amount for the invoice match to be successful');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'ipn', 'B', 'PAYPAL_WRITEDEBUG', 'PayPal: Enable Text Log', '0', 'Create a text file to log IPN connection attempts to and from PayPal.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'ipn', 'S', 'PAYPAL_DEBUGFILE', 'PayPal: Name of Text Log', 'c:/temp/paypal_ipn_%TIMESTAMP%.log', 'Name of text file to log IPN connection attempts to and from PayPal (Use %TIMESTAMP% to have current timestamp appended)');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'ipn', 'S', 'PAYPAL_SBEMAIL', 'PayPal: SandBox Seller Email', 'paypal_111111111_biz@yourdoman.com', 'Sandbox email address of seller, for testing IPN with PayPal');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'operation', 'B', 'INCOMING_EMAIL_AS_HTML', 'Email: Enable Incoming HTML email', '0', 'Allow "contact us" form to send you html email or only plain ascii text');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'todo', 'I', 'IPP_TODO', 'Listing Items Per Page for: ToDo', '10', 'Determines the number of ToDo items that are displayed in listing form on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','operation','B','ENABLE_SUPPORT_ON_CONTACT','Show support on Contact form','1','whether or not to enable the "support" address on the contact form');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'NO_NAG_ON_CREDIT', 'Do Not Nag If Credit Balance', '1', 'Whether a client should be nagged for all unpaid invoices, or only if they exceed their prepaid credit balance');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'SHOW_EMPTY_INVC_STATUS', 'Show Unused Invoices Statuses on Summary', '0', 'IF YES, the invoice columnar listing will show a row for each invoice status, whether any invoices have that status or not. If NO, then only statuses that are used on an invoice will be shown');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'SHOW_INVC_ZERO_TOTAL', '$0.00 on Zero Totals or Blank', '1', 'If YES, zero value billing cycle totals will display as $0.00 If NO, zero value billing cycle totals will display as a blank space');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'B', 'PAYPAL_AUTO_VERBOSE', 'PayPal Emails: Verbose Progress Display', '1', 'Whether to display the processing of each message, or only the agregate results');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'B', 'PAYPAL_AUTO_IMPORT_ENABLE', 'PayPal Emails: Import Enable', '1', 'If "Yes", paypal.php will connect to a POP or IMAP box and attempt to create payments from any paypal messages found.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_IMPORT_SERVER', 'PayPal Emails: Auto-import server', 'mail.%DOMAINNAME%', 'Name of the email server to connect to for auto-importing paypal payment messages.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_IMPORT_TYPE', 'PayPal Emails: Auto-import protocol', ':143/imap/notls', 'Protocol and port to connect. "/:143/imap" seems to work better than "/pop:110". You may also need to try /IMAP/:143/notls or /:110/POP/notls depending on your mailserver');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_IMPORT_USERID', 'PayPal Emails: Auto-import mailbox', 'sales@%DOMAINNAME%', 'The mailbox to connect to for helpdesk auto-import.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_IMPORT_PASSWORD', 'PayPal Emails: Auto-import password', 'password', 'Password for the email box that will be checked automaticaly.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'I', 'PAYPAL_AUTO_IMPORT_DELETE_MESSAGES', 'PayPal Emails: Auto-import delete', '1', 'Delete _these_ messages on the mail-server');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_PARTIAL_SUBJECT', 'PayPal Emails: Partial Subject String', 'Notification of Payment Received', 'Emails from PayPal will include this text in the subject line');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_INVOICE_ID', 'PayPal Emails: Invoice ID String', 'Invoice ID', 'Emails from PayPal will include this text in the Invoice ID line');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_TRANS_ID', 'PayPal Emails: Transaction ID String', 'Transaction ID', 'Emails from PayPal will include this text in the Transaction ID line');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'ipn', 'S', 'PAYPAL_AUTO_TOTAL_AMT', 'PayPal Emails: Total Amount String', 'Total Amount', 'Emails from PayPal will include this text in the Total Amount line');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'clients', 'B', 'CLIENT_NOTES_VISIBLE', 'Notes Visible To Clients', '0', 'Whether or not client notes should be viewable by the client');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'invoices', 'B', 'INVC_ACOPY_NEW_TERMS', 'Invoice AutoCopy Terms- Insert New', '0', 'If "Yes", phpCOIN will replace the existing terms on auto-copied invoices with whatever the current terms are in lang_config.php. If "No", phpCOIN will copy any existing terms on the invoice as-is');
INSERT INTO %PREFIX%parameters (parm_group, parm_group_sub, parm_type, parm_name, parm_desc, parm_value, parm_notes) VALUES ('common', 'invoices', 'I', 'TAX_DISPLAY_DIGITS_PERCENT', 'Display Digits For Tax Percent', '3', 'How many digits after the decimal place should we display for the tax percentages?');
INSERT INTO %PREFIX%parameters (parm_group, parm_group_sub, parm_type, parm_name, parm_desc, parm_value, parm_notes) VALUES ('common', 'invoices', 'I', 'TAX_DISPLAY_DIGITS_AMOUNT', 'Display Digits For Tax Amount', '2', 'How many digits after the decimal place should we display for the tax amounts?');
INSERT INTO %PREFIX%parameters (parm_group, parm_group_sub, parm_type, parm_name, parm_desc, parm_value, parm_notes) VALUES ('common', 'invoices', 'I', 'CURRENCY_DISPLAY_DIGITS_AMOUNT', 'Display Digits For Currency Amounts', '2', 'How many digits after the decimal place should we display for currency (non-tax) amounts?');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_TOS_IN_IFRAME', 'Display TOS in Iframe', '1', 'Whether or not to show the TOS in an iframe on the orders page, underneath the "Accept TOS" checkbox');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'orders', 'B', 'ORDERS_AUP_IN_IFRAME', 'Display AUP in Iframe', '1', 'Whether or not to show the AUP in an iframe on the orders page, underneath the "Accept AUP" checkbox');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'I', 'SUMMARY_PRODUCTS_ORDER_BY', 'Summary- Product Orders Sort Order', '1', 'Determine the sort order for product orders on the Summary page:\r\n1: Alphabetical by product name or description\r\n2: Reverse alphabetical by product name or description\r\n3: Number of products sold, low to high\r\n4: Number of products sold, high to low\r\n5: Value of products sold, low to high\r\n6: Value of products sold, high to low');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'suppliers', 'B', 'SUPPLIERS_ENABLE', 'Suppliers Enable (Visible)', '1', 'Determines if the Suppliers module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'suppliers', 'I', 'BASE_SUPPLIER_ID', 'Supplier ID Base-Initial Value Minus 1', '1000', 'Determines the supplier id initial value for the first supplier entered in the system. Supplier ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'suppliers', 'I', 'IPP_SUPPLIERS', 'Listing Items Per Page for: Suppliers', '15', 'Determines the number of suppliers that are displayed on a page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'suppliers', 'I', 'IPL_SUPPLIERS', 'Listing Items Per List for: Supplier Account', '5', 'Determines the number of most recent items (bills and emailarchive messages) that are displayed on a suppliers account page.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'bills', 'B', 'BILL_ACOPY_DELAY_ENABLE', 'Bill Auto-Copy Delay Enable', '1', 'Determines if the auto-copy of recurring bills is delayed until new bill date is within days out setting.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'bills', 'I', 'BILL_ACOPY_DAYS_OUT', 'Bill Auto-Copy Days Out to Copy', '15', 'Determines number of days from current date to auto-copy a recurring bill. Will auto-copy if the new bill date falls within this date range.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'bills', 'B', 'BILL_AUTO_UPDATE_ENABLE', 'Bill Auto-Update of Status Enable', '1', 'Determines if the auto-update of bill status function is enabled when triggered by cron job or manually by command summary actions menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('automation', 'bills', 'B', 'BILL_AUTO_COPY_ENABLE', 'Bill Auto-Copy Recurring Enable', '1', 'Determines if the auto-copy of recurring bills function is enabled when triggered by cron job or manually by command summary actions menu.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'I', 'BILL_DUE_DAYS_OFFSET', 'Bill Due Date Offset from Create in Days', '15', 'Determines the number of days to add to current date and set the due date to when creating a new bill.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILL_TAX_01_ENABLE', 'Bill Tax 01 Enable', '1', 'Determines if bill tax 01 is enabled for display.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILL_TAX_02_ENABLE', 'Bill Tax 02 Enable', '1', 'Determines if bill tax 02 is enabled for display.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILL_SPLIT_TRANS_LIST_ENABLE', 'Bill Transaction Listing Split Enable', '0', 'Determines if the bill transaction listing is split to list charges on top, and then credits below (in seperate list).');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'S', 'BILL_TAX_01_LABEL', 'Bill Tax 01 Text Label', '13% HST:', 'Determines the text label displayed on bills in place of "Tax 01".');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'S', 'BILL_TAX_02_LABEL', 'Bill Tax 02 Text Label', '5% PST:', 'Determines the text label displayed on bills in place of "Tax 01".');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'I', 'BILL_VIEW_SHOW_TRANS', 'Bill View Show Transactions Enable', '3', 'Determines if the bill transactions listing is displayed on lower portion of bill view. 0: No, 1: On-Screen Only, 2: Printed Only, 3: Onscreen and Printed ');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILLS_ENABLE', 'Bills Enable (Visible)', '1', 'Determines if the Bills module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'R', 'BILL_TAX_01_DEF_VAL', 'Bill Tax 01 Rate Default Value', '13.00', 'Determines the default tax rate percentage value inserted for this tax. Example 1.00 equates to 1 percent.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'R', 'BILL_TAX_02_DEF_VAL', 'Bill Tax 02 Rate Default Value', '5.00', 'Determines the default tax rate percentage value inserted for this tax. Example 1.00 equates to 1 percent.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'I', 'BASE_BILL_ID', 'Bill ID Base-Initial Value Minus 1', '1000', 'Determines the bill id initial value for the first bill entered in the system. Bill ID will be this value plus one.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'B', 'SUMMARY_BILLS_BY_PRODUCT', 'Summary: Display expenses that have been billed', '1', 'If "Yes", phpCOIN will display a table with the number of times each billed expense appears on a bill, as well as the total value.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'summary', 'S', 'SUMMARY_BILLS_BY_PRODUCT_IGNORE', 'Summary: Ignore these billed expenses', '', 'A pipe-separated list of item codes on bills that should be ignored when building the billed expenses summary.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILL_TAX_BY_ITEM', 'Bill Tax By Item Enable', '1', 'Determines if the taxes are applied at the items level (each item), or just on the total of items.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'I', 'IPP_BILLS', 'Listing Items Per Page for: Bills', '15', 'Determines the number of bills that are displayed  in listing form on a page.\r\n');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'bills', 'B', 'BILL_PRICES_INCLUDE_TAXES', 'Bill Taxes Are Included In Price', '0', 'If "No", phpCOIN will add applicable taxes to items on invoices. If "Yes", phpCOIN assumes that the prices include tax. In that event, taxes will be removed from the items and then recalculated, so the bill can show the amount of taxes included in the prices.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'ipn', 'B', '2CHECKOUT_WRITEDEBUG', '2Checkout: Enable Text Log', '0', 'Create a text file to log IPN connection attempts to and from 2Checkout.');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common', 'ipn', 'S', '2CHECKOUT_DEBUGFILE', '2Checkout: Name of Text Log', 'c:/temp/2co_ipn_%TIMESTAMP%.log', 'Name of text file to log IPN connection attempts to and from 2Checkout (Use %TIMESTAMP% to have current timestamp appended)');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','S','2CHECKOUT_SECRET_WORD','2Checkout: INS Secret Word','SECRET','Incoming INS transactiosn will have this secret word as part of the MD5 hash, to help assure that the data is from 2Checkout');
INSERT INTO %PREFIX%parameters (`parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('common','ipn','S','2CHECKOUT_VENDOR_ID','2Checkout: Vendor ID','1234567','Incomeing INS transactiosn will include your 2co vendor ID, so we can assure that the transaction was meant for you');
CREATE TABLE %PREFIX%products (prod_id smallint(6) NOT NULL auto_increment, prod_status tinyint(1) NOT NULL default 1, prod_name varchar(20) NOT NULL default '', prod_desc varchar(75) NOT NULL default '', prod_unit_cost double NOT NULL default '0', prod_client_scope int(11) NOT NULL default 0, prod_apply_tax_01 tinyint(1) NOT NULL default 1, prod_apply_tax_02 tinyint(1) NOT NULL default 1, prod_calc_tax_02_pb tinyint(1) NOT NULL default 0, prod_dom_type tinyint(2) NOT NULL default 0, prod_allow_domains smallint(6) NOT NULL default 0, prod_allow_subdomains smallint(6) NOT NULL default 0, prod_allow_disk_space_mb int(11) NOT NULL default 0, prod_allow_traffic_mb int(11) NOT NULL default 0, prod_allow_mailboxes smallint(6) NOT NULL default 0, prod_allow_databases smallint(6) NOT NULL default 0, prod_cg_01 tinyint(1) NOT NULL default 0, prod_cg_02 tinyint(1) NOT NULL default 0, prod_cg_03 tinyint(1) NOT NULL default 0, prod_cg_04 tinyint(1) NOT NULL default 0, prod_cg_05 tinyint(1) NOT NULL default 0, prod_cg_06 tinyint(1) NOT NULL default 0, prod_cg_07 tinyint(1) NOT NULL default 0, prod_cg_08 tinyint(1) NOT NULL default 0, PRIMARY KEY (prod_id)) TYPE=MyISAM COMMENT='Site Products Table' AUTO_INCREMENT=3;
INSERT INTO %PREFIX%products (`prod_id`, `prod_status`, `prod_name`, `prod_desc`, `prod_unit_cost`, `prod_client_scope`, `prod_apply_tax_01`, `prod_apply_tax_02`, `prod_calc_tax_02_pb`, `prod_dom_type`, `prod_allow_domains`, `prod_allow_subdomains`, `prod_allow_disk_space_mb`, `prod_allow_traffic_mb`, `prod_allow_mailboxes`, `prod_allow_databases`, `prod_cg_01`, `prod_cg_02`, `prod_cg_03`, `prod_cg_04`, `prod_cg_05`, `prod_cg_06`, `prod_cg_07`, `prod_cg_08`) VALUES (1, 1, 'ID-0001', 'Sample Hosting Product 01', '19.95', 0, 1, 1, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
INSERT INTO %PREFIX%products (`prod_id`, `prod_status`, `prod_name`, `prod_desc`, `prod_unit_cost`, `prod_client_scope`, `prod_apply_tax_01`, `prod_apply_tax_02`, `prod_calc_tax_02_pb`, `prod_dom_type`, `prod_allow_domains`, `prod_allow_subdomains`, `prod_allow_disk_space_mb`, `prod_allow_traffic_mb`, `prod_allow_mailboxes`, `prod_allow_databases`, `prod_cg_01`, `prod_cg_02`, `prod_cg_03`, `prod_cg_04`, `prod_cg_05`, `prod_cg_06`, `prod_cg_07`, `prod_cg_08`) VALUES (2, 1, 'ID-0002', 'Sample Non-Hosting Product 02', '29.95', 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
CREATE TABLE %PREFIX%reminders (overdue_id int(11) NOT NULL auto_increment, overdue_title varchar(50) NOT NULL default '', overdue_active char(1) NOT NULL default 1, overdue_days tinyint(4) NOT NULL default 10, overdue_subject varchar(150) NOT NULL default '', overdue_template text NOT NULL, overdue_cc_support tinyint(1) NOT NULL default 0, UNIQUE KEY overdue_id (overdue_id)) TYPE=MyISAM AUTO_INCREMENT=5;
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (0, 'Soon Due', '1', 0, 'Account Soon Due', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated reminder that your account recently had an invoice issued that will soon be due, with an outstanding account balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\n.  If you have already made payment arrangements, we thank you for your diligence and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (1, '10 Days Overdue', '1', 10, 'Account Overdue', 'Hello $_MTP[to_name];\r\n\r\nWe realize that everyone gets busy and occasionally overlooks things.  Unfortunately, we appear to have been overlooked this time.\r\n\r\nThis email is an automated notification that your account is now ten days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  If you have already made payment arrangements, we thank you for your diligence and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (2, '20 Days Overdue', '1', 20, 'Account Seriously Overdue', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated notification that your account is now twenty days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take immediate action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  Failure to do so may result in additional collection steps and/or costs.  If you have already made payment arrangements, we thank you and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nCollection Department\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (3, '30 Days Overdue', '1', 30, 'Account Suspended', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated notification that your account is now thirty days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nThis is a very serious situation, and your account has been suspended.  To have your account re-instated, you must pay your outstanding balance in full plus a re-instatement fee of $20, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  Failure to pay everything owed within the next 15 days WILL result in ALL of your website, database and email files being deleted FOREVER.\r\n\r\nIf you have already made payment arrangements, we thank you and apologize for this automated reminder.\r\n\r\n\r\nRespectfully Yours,\r\nCollection Manager\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (4, '1 Day Overdue', '1', 1, 'A Gentle Reminder', 'Hello $_MTP[to_name];\r\n\r\nWe realize that everyone gets busy and occasionally overlooks things.  Unfortunately, we appear to have been overlooked this time.\r\n\r\nThis email is an automated notification that your account is now overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  If you have already made payment arrangements, we thank you for your diligence and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]', 1);
CREATE TABLE %PREFIX%server_info (si_id smallint(6) NOT NULL auto_increment, si_name varchar(20) NOT NULL default '', si_ip varchar(15) NOT NULL default '000.000.000.000', si_ns_01 varchar(50) NOT NULL default '', si_ns_01_ip varchar(15) NOT NULL default '000.000.000.000', si_ns_02 varchar(50) NOT NULL default '', si_ns_02_ip varchar(15) NOT NULL default '000.000.000.000', si_cp_url varchar(50) NOT NULL default '', si_cp_url_port int(11) NOT NULL default 0, PRIMARY KEY (si_id)) TYPE=MyISAM COMMENT='Site Server Info Table' AUTO_INCREMENT=3;
INSERT INTO %PREFIX%server_info (`si_id`, `si_name`, `si_ip`, `si_ns_01`, `si_ns_01_ip`, `si_ns_02`, `si_ns_02_ip`, `si_cp_url`, `si_cp_url_port`) VALUES (1, 'Alpha', '216.118.66.244', 'NS1.NAMESERVER.COM', '000.000.000.000', 'NS2.NAMESERVER.COM', '000.000.000.000', 'https://www.server.com:8443/login.php3', 8443);
INSERT INTO %PREFIX%server_info (`si_id`, `si_name`, `si_ip`, `si_ns_01`, `si_ns_01_ip`, `si_ns_02`, `si_ns_02_ip`, `si_cp_url`, `si_cp_url_port`) VALUES (2, 'Beta', '216.118.66.245', 'NS1.NAMESERVER.COM', '000.000.000.000', 'NS2.NAMESERVER.COM', '000.000.000.000', 'https://www.server.com:8443/login.php3', 8443);
CREATE TABLE %PREFIX%sessions (s_id varchar(36) NOT NULL default '', s_time_init int(11) NOT NULL default 0, s_time_last int(11) NOT NULL default 0, s_ip varchar(16) NOT NULL default '000.000.000.000', s_is_admin tinyint(1) NOT NULL default 0, s_is_user tinyint(1) NOT NULL default 0, s_time_last_contact int(11) NOT NULL default 0, s_time_last_order int(11) NOT NULL default 0, PRIMARY KEY (s_id)) TYPE=MyISAM COMMENT='Site Sessions Table';
CREATE TABLE %PREFIX%site_info (si_id int(11) NOT NULL auto_increment, si_group varchar(32) default NULL, si_name varchar(32) default NULL, si_seq_no int(11) default NULL, si_desc varchar(50) default NULL, si_block_it tinyint(1) NOT NULL default 0, si_title varchar(50) default NULL, si_code longtext, si_status tinyint(1) NOT NULL default 0, si_footer_menu tinyint(1) NOT NULL default 1, PRIMARY KEY (si_id)) TYPE=MyISAM COMMENT='Site SiteInfo Table' AUTO_INCREMENT=10;
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (1, 'site', 'index', 0, 'Index Block HTML code.', 1, 'Welcome', '<div><p><img src="coin_images/phpcoin_box.gif" border="0" align="right" hspace="5" vspace="3">Welcome to your phpCOIN install at $_CCFG[_PKG_NAME_SHORT]. Installation is now complete, but there are still some things you need to configure before you can fully utilize phpCOIN:</p><ul><li>Your administrator username is <span style="font-weight: bold; color: red;">webmaster</span></li><li>Your password is your <span style="font-weight: bold; color: red;">database password</span></li><li>Read the online manual at <a href="http://docs.phpcoin.com/">http://docs.phpCOIN.com</a> for help with configuration and operations</li><li>If you still have any questions, consult the support forums at <a href="http://forums.phpCOIN.com/">http://forums.phpCOIN.com</a></li><li>You <i>should</i> login and change the text of this page immediately.</li></ul><p>The Cost:</p><ul><li>phpCOIN version 1.x is 100% <i>free</i> of cost to install and use</li><li>A <a href="http://www.phpcoin.com/mod.php?mod=siteinfo&id=10">donation</a> to help cover development and support expenses would be appreciated, but is <i>not</i> required</li></ul><p>Support Options:</p><ul><li>Support via the phpCOIN <a href="http://forums.phpcoin.com/">support forums</a> or the <a href="http://docs.phpcoin.com/">online manual</a> is <i>free</i></li><li>Support via email <i>will</i> be billed at $50 per question. If your question was already answered in the support forums or in the online manual, the fee will increase to $100 per question so <i>please</i> check the manual and forums <i>first</i>. Please include your credit card information or your email/fax <i>will</i> be ignored</li><li>At the present time support via telephone and/or facsimile is not available</li><li>Several users have created free themes and/or translations and/or other modules. Please see the phpCOIN <a href="http://www.phpcoin.com/mod.php?mod=downloads">downloads page</a></li></ul><p>License Terms:</p><ul><li>You <i>explicitly</i> accepted the <a href="coin_docs/license.txt">phpCOIN license terms</a> during the installation process.</li><li>Failure to comply with the <a href="coin_docs/license.txt">phpCOIN license terms</a> may cause an offending website to be listed on the phpCOIN <a href="http://www.phpcoin.com/auxpage.php?page=shame">Wall of Shame</a> until compliant.</li></ul><p>Thank you for trying phpCOIN.</p><p>%GOOGLE_H%</p></div>', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (2, 'site', 'greeting', 0, 'Site greeting html code. Placed on index page', 1, 'Site Greeting', 'For a site greeting?', 0, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (3, 'site', 'announce', 0, 'For Top billing announcement on index page.', 1, 'Announcement', 'For a site announcment?', 0, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (4, 'site', 'about', 0, 'About this site info page.', 1, 'About This Site', '<center>\r\n<p><br>This is where you tell them about $_CCFG[_PKG_NAME_SHORT].\r\n<br><br>\r\n</center>', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (5, 'site', 'policy_privacy', 0, 'Privacy Policy', 1, 'Privacy Policy', '<p>$_CCFG[_PKG_NAME_SHORT] is committed to the privacy of our clients.  ...... typical Privacy Polic policy page.<br><br>\r\n', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (6, 'site', 'policy_acceptable_use', 0, 'Acceptable Use Policy', 1, 'Acceptable Use Policy', '<p>...... typical Acceptable Use Policy policy page.<br><br>\r\n', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (7, 'site', 'policy_terms_of_service', 0, 'Terms Of Service', 1, 'Terms Of Service', '<p>When using the Service provided by $_CCFG[_PKG_NAME_SHORT], ...... typical Terms Of Service policy page.<br><br\r\n>', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (8, 'site', 'policy_banned_code', 0, 'Banned Code', 1, 'Banned Code', '<p>...... typical Banned Code policy page.<br><br>\r\n', 1, 1);
INSERT INTO %PREFIX%site_info (`si_id`, `si_group`, `si_name`, `si_seq_no`, `si_desc`, `si_block_it`, `si_title`, `si_code`, `si_status`, `si_footer_menu`) VALUES (9, 'site', 'dream', 0, 'A Kind Of Dream', 0, 'A Kind Of Dream', '<!-- Start content -->\r\n	<br><br>\r\n		<div align="center">\r\n			<p><font face="Comic Sans MS" size="2">We can walk our road together<br>\r\n					If our goals are all the same.<br>\r\n					We can run alone and free<br>\r\n					If we pursue a different aim.<br>\r\n					Let the Truth of Love be lighted,<br>\r\n					Let the Love of Truth shine clear. Sensibility,<br>\r\n					Armed with sense and liberty,<br>\r\n					With the Heart and Mind united in a single<br>\r\n					Perfect<br>\r\n					Sphere.</font></p>\r\n			<p><i><font face="Comic Sans MS" size="1">The Sphere: A Kind of Dream (Rush: Hemispheres)</font></i></p>\r\n		</div><p>%GOOGLE_H%</p>\r\n\r\n', 1, 1);
CREATE TABLE %PREFIX%todo (`todo_id` smallint(6) NOT NULL auto_increment, `todo_admin_id` smallint(6) default '0', `todo_title` varchar(255) default '0', `todo_text` text, `todo_duedate` varchar(15) default '0', `todo_entered` varchar(15) default '0', `todo_completed` tinyint(1) default '0', `todo_priority` int(2) default '1', PRIMARY KEY (`todo_id`)) TYPE=MyISAM;
CREATE TABLE %PREFIX%topics (topic_id mediumint(9) NOT NULL auto_increment, topic_pos smallint(6) NOT NULL default 0, topic_name varchar(50) NOT NULL default '', topic_desc varchar(50) NOT NULL default '', topic_icon smallint(6) NOT NULL default 1, PRIMARY KEY (topic_id)) TYPE=MyISAM COMMENT='Site Topics Table' AUTO_INCREMENT=5;
INSERT INTO %PREFIX%topics (`topic_id`, `topic_pos`, `topic_name`, `topic_desc`, `topic_icon`) VALUES (1, 0, 'General', 'General / Default Topic', 1);
INSERT INTO %PREFIX%topics (`topic_id`, `topic_pos`, `topic_name`, `topic_desc`, `topic_icon`) VALUES (2, 0, 'Announcements', 'For Announcements', 1);
INSERT INTO %PREFIX%topics (`topic_id`, `topic_pos`, `topic_name`, `topic_desc`, `topic_icon`) VALUES (3, 0, 'Documentation', 'For Documentation', 1);
INSERT INTO %PREFIX%topics (`topic_id`, `topic_pos`, `topic_name`, `topic_desc`, `topic_icon`) VALUES (4, 0, 'News', 'For News', 1);
CREATE TABLE %PREFIX%vendors (vendor_id smallint(6) NOT NULL auto_increment, vendor_status tinyint(1) NOT NULL default 0, vendor_name varchar(20) NOT NULL default '', vendor_buy_parm varchar(30) NOT NULL default 'buy', vendor_buy_parm_val varchar(10) NOT NULL default '1', vendor_url varchar(50) NOT NULL default '', vendor_use_ipn tinyint(1) NOT NULL default 0, vendor_notes text NOT NULL, PRIMARY KEY (vendor_id)) TYPE=MyISAM COMMENT='Site Vendors Table';
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (1, 1, 'Paypal', 'buy', '1', 'http://www.paypal.com', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/PayPal for PayPal specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (2, 0, '2Checkout', 'credit_card_processed', 'Y', 'http://www.2checkout.com', '0', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/2Checkout for 2Checkout specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (3, 0, 'Bank Transfer', 'transfer', '1', 'http://YOURWEBSITE/mod.php?mod=orders&mode=return', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/Bank_Transfer for Bank Transfer specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (4, 0, 'BRPay', 'Status', '1', 'http://www.brpay.com.br/', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. You also need to download the BRPay callback file. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/BRPay for BRPay specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (5, 0, 'Cheque/Money Order', 'cheque', '1', 'http://YOURWEBSITE/mod.php?mod=orders&mode=return', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/Cheque/Money_Order for Cheque/Money Order specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (6, 0, 'E-xact', 'exact', '1', 'http://www.e-xact.com/', '0', 'You need to insert one PayLink for each product/service that will use this as a payment method. You also need to download the E-xact callback file. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/E-xact for E-xact specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (7, 0, 'MoneyBookers', 'moneybookers', '1', 'http://www.moneybookers.com/', '0', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/MoneyBookers for MoneyBookers specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (8, 0, 'PayMate', 'buy', '1', 'http://www.paymate.com.au/', '0', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/PayMate for PayMate specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (9, 0, 'Purchase Order', 'po', '1', 'http://YOURWEBSITE/mod.php?mod=orders&mode=return', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/Purchase_Order for general PayLink information and variables, and http://docs.phpcoin.com/index.php/Purchase_Order for Purchase Order specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (10, 0, 'Quantum Gateway', 'quantum', '1', 'http://www.quantumgateway.com/', '0', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/Quantum_Gateway for Quantum Gateway specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (11, 0, 'e-gold', 'egold', '1', 'http://www.e-gold.com', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/e-gold for e-gold specific PayLink information');
INSERT INTO %PREFIX%vendors (`vendor_id`, `vendor_status`, `vendor_name`, `vendor_buy_parm`, `vendor_buy_parm_val`, `vendor_url`, `vendor_use_ipn`, `vendor_notes`) VALUES (12, 0, 'AlertPay', 'alertpay', '1', 'https://www.alertpay.com', '1', 'You need to insert one PayLink for each product/service that will use this as a payment method. See http://docs.phpcoin.com/index.php/PayLinks for general PayLink information and variables, and http://docs.phpcoin.com/index.php/AlertPay for AlertPay specific PayLink information');
CREATE TABLE %PREFIX%vendors_prods (vprod_id smallint(6) NOT NULL auto_increment, vprod_vendor_id smallint(6) NOT NULL default 0, vprod_prod_id smallint(6) NOT NULL default 0, vprod_desc varchar(50) NOT NULL default '', vprod_order_link text NOT NULL, PRIMARY KEY (vprod_id)) TYPE=MyISAM COMMENT='Site Vendor Products Table';
INSERT INTO %PREFIX%vendors_prods (`vprod_id`, `vprod_vendor_id`, `vprod_prod_id`, `vprod_desc`, `vprod_order_link`) VALUES (1, 1, 1, 'Sample: Paypal - Product 1', '<form action="https://www.paypal.com/cgi-bin/webscr" method="post"><input type="hidden" name="rm" value="2"><input type="hidden" name="cmd" value="_xclick"><input type="hidden" name="business" value="YourPaypalEmailAddress@YourEmailsDomain.com"><input type="hidden" name="item_name" value="<prod_desc>"><input type="hidden" name="item_number" value="<prod_desc>"><input type="hidden" name="no_shipping" value="1"><input type="hidden" name="no_note" value="1"><input type="hidden" name="currency_code" value="USD"><input type="hidden" name="amount" value="<total_amt>"><input type="hidden" name="return" value="<return_link_buy>"><input type="hidden" name="cancel_return" value="<return_link_cancel>"><input type="hidden" name="notify_url" value="<return_link_ipn>paypal.php"><input type="image" src="https://www.paypal.com/en_US/i/btn/x-click-butcc.gif" border="0" name="submit" alt="Make payment - it is fast, free and secure!"></form>');
INSERT INTO %PREFIX%vendors_prods (`vprod_id`, `vprod_vendor_id`, `vprod_prod_id`, `vprod_desc`, `vprod_order_link`) VALUES (2, 1, 2, 'Sample: Paypal - Product 2', '<form action="https://www.paypal.com/cgi-bin/webscr" method="post"><input type="hidden" name="rm" value="2"><input type="hidden" name="cmd" value="_xclick"><input type="hidden" name="business" value="YourPaypalEmailAddress@YourEmailsDomain.com"><input type="hidden" name="item_name" value="<prod_desc>"><input type="hidden" name="item_number" value="<prod_desc>"><input type="hidden" name="no_shipping" value="1"><input type="hidden" name="no_note" value="1"><input type="hidden" name="currency_code" value="USD"><input type="hidden" name="amount" value="<total_amt>"><input type="hidden" name="return" value="<return_link_buy>"><input type="hidden" name="cancel_return" value="<return_link_cancel>"><input type="hidden" name="notify_url" value="<return_link_ipn>paypal.php"><input type="image" src="https://www.paypal.com/en_US/i/btn/x-click-butcc.gif" border="0" name="submit" alt="Make payment - it is fast, free and secure!"></form>');
INSERT INTO %PREFIX%vendors_prods (`vprod_id`, `vprod_vendor_id`, `vprod_prod_id`, `vprod_desc`, `vprod_order_link`) VALUES (3, 2, 1, 'Sample: 2Checkout - Product 1', '<p><form action="https://www.2checkout.com/2co/buyer/purchase" method="post"><input type="hidden" name="id_type" value="1"><input type="hidden" name="sid" value="XXXXX"><input type="hidden" name="c_prod" value="YYYYY"><input type="hidden" name="c_name" value="<prod_name>"><input type="hidden" name="c_description" value="<prod_desc>"><input type="hidden" name="c_price" value="<prod_unit_cost>"><input type="hidden" name="c_tangible" value="N"><input type="hidden" name="cart_order_id" value="<order_id>"><input type="hidden" name="total" value="<total_amt>"><input type="submit" value="Click to buy thru 2CheckOut"></form>2Checkout.com, Inc. is an authorized retailer of goods and services provided by %DOMAINNAME%</p>');
INSERT INTO %PREFIX%vendors_prods (`vprod_id`, `vprod_vendor_id`, `vprod_prod_id`, `vprod_desc`, `vprod_order_link`) VALUES (4, 2, 2, 'Sample: 2Checkout - Product 2', '<p><form action="https://www.2checkout.com/2co/buyer/purchase" method="post"><input type="hidden" name="id_type" value="1"><input type="hidden" name="sid" value="XXXXX"><input type="hidden" name="c_prod" value="YYYYY"><input type="hidden" name="c_name" value="<prod_name>"><input type="hidden" name="c_description" value="<prod_desc>"><input type="hidden" name="c_price" value="<prod_unit_cost>"><input type="hidden" name="c_tangible" value="N"><input type="hidden" name="cart_order_id" value="<order_id>"><input type="hidden" name="total" value="<total_amt>"><input type="submit" value="Click to buy thru 2CheckOut"></form>2Checkout.com, Inc. is an authorized retailer of goods and services provided by %DOMAINNAME%</p>');
CREATE TABLE %PREFIX%whois (whois_id int(11) NOT NULL auto_increment, whois_server varchar(100) NOT NULL default '', whois_nomatch varchar(40) NOT NULL default '', whois_value varchar(20) NOT NULL default '', whois_display varchar(25) NOT NULL default '', whois_include tinyint(1) NOT NULL default 1, whois_prod_id int(11) NOT NULL default 0, whois_notes text, UNIQUE KEY whois_id (whois_id)) TYPE=MyISAM AUTO_INCREMENT=28;
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (1, 'whois.cira.ca', 'Status:AVAIL', 'ca', '.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (2, 'whois.nic.biz', 'Not found', 'biz', '.biz', 0, 0, 'Must be registered to get WHOIS results for .biz');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (3, 'whois.cira.ca', 'Status:AVAIL', 'ab.ca', '.ab.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (4, 'whois.cira.ca', 'Status:AVAIL', 'bc.ca', '.bc.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (5, 'whois.cira.ca', 'Status:AVAIL', 'mb.ca', '.mb.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (6, 'whois.cira.ca', 'Status:AVAIL', 'nb.ca', '.nb.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (7, 'whois.cira.ca', 'Status:AVAIL', 'ns.ca', '.ns.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (8, 'whois.cira.ca', 'Status:AVAIL', 'nf.ca', '.nf.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (9, 'whois.cira.ca', 'Status:AVAIL', 'on.ca', '.on.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (10, 'whois.cira.ca', 'Status:AVAIL', 'pe.ca', '.pe.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (11, 'whois.cira.ca', 'Status:AVAIL', 'pq.ca', '.pq.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (12, 'whois.cira.ca', 'Status:AVAIL', 'sk.ca', '.sk.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (13, 'whois.internic.net', 'no match', 'com net', '.com .net', 0, 0, 'Handles .com and .net domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (14, 'whois.internic.net', 'no match', 'com', '.com', 1, 0, 'Handles .com domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (15, 'whois.internic.net', 'no match', 'net', '.net', 1, 0, 'Handles .net domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (16, 'whois.opensrs.net', 'Not found', 'info', '.info', 1, 0, 'Handles .info domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (17, 'whois.publicinterestregistry.net', 'NOT FOUND', 'org', '.org', 1, 0, 'Handles .org domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (18, 'whois.dns.pl', 'does not exists', 'pl com.pl', '.pl .com.pl', 0, 0, 'Handles .pl and .com.pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (19, 'whois.dns.pl', 'does not exists', 'pl', '.pl', 0, 0, 'Handles .pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (20, 'whois.dns.pl', 'does not exists', 'com.pl', '.com.pl', 0, 0, 'Handles .com.pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (21, 'whois.nic.uk', 'No match', 'uk', '.uk', 0, 0, 'Handles .uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (22, 'whois.nic.uk', 'No match', 'co.uk org.uk me.uk', '.co.uk .org.uk .me.uk', 0, 0, 'Handles various combined .uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (23, 'whois.nic.uk', 'No match', 'co.uk', '.co.uk', 0, 0, 'Handles .co.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (24, 'whois.nic.uk', 'No match', 'org.uk', '.org.uk', 0, 0, 'Handles .org.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (25, 'whois.nic.uk', 'No match', 'me.uk', '.me.uk', 0, 0, 'Handles .me.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (26, 'whois.nic.us', 'Not found:', 'us', '.us', 0, 0, 'Handles .us domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (27, 'whois.nic.cc', 'No Match', 'cc', '.cc', 0, 0, 'Handles .cc domains');
CREATE TABLE IF NOT EXISTS %PREFIX%bills (`bill_id` int(11) NOT NULL default '0', `bill_status` varchar(20) NOT NULL default 'draft', `bill_s_id` int(11) NOT NULL default '0', `bill_invoice_number` varchar(20) NOT NULL default '', `bill_total_cost` double default '0', `bill_total_paid` double default '0', `bill_subtotal_cost` double default '0', `bill_tax_01_percent` double default '0', `bill_tax_01_amount` double default '0', `bill_tax_02_percent` double default '0', `bill_tax_02_amount` double default '0', `bill_tax_autocalc` tinyint(1) NOT NULL default '1', `bill_ts` int(11) NOT NULL, `bill_ts_due` int(11) NOT NULL, `bill_ts_paid` int(11) NOT NULL, `bill_cycle` tinyint(1) NOT NULL default '1', `bill_recurring` tinyint(1) NOT NULL default '0', `bill_recurr_proc` tinyint(4) NOT NULL default '0',  PRIMARY KEY (`bill_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Site Bills Module Table';
CREATE TABLE IF NOT EXISTS %PREFIX%bills_items (`bi_bill_id` int(11) NOT NULL default '0', `bi_item_no` smallint(4) NOT NULL default '0', `bi_item_name` varchar(30) NOT NULL default '', `bi_item_desc` varchar(75) NOT NULL default '', `bi_item_cost` double default '0', `bi_apply_tax_01` tinyint(1) NOT NULL default '1', `bi_apply_tax_02` tinyint(1) NOT NULL default '1', `bi_calc_tax_02_pb` tinyint(1) NOT NULL default '0', PRIMARY KEY (`bi_bill_id`,`bi_item_no`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Site Bills Module Items Table';
CREATE TABLE IF NOT EXISTS %PREFIX%bills_trans (`bt_id` bigint(11) NOT NULL auto_increment, `bt_ts` int(11) NOT NULL, `bt_bill_id` int(11) NOT NULL default '0', `bt_type` tinyint(2) NOT NULL default '0', `bt_origin` tinyint(2) NOT NULL default '0', `bt_desc` varchar(50) NOT NULL default '', `bt_amount` double default '0', PRIMARY KEY (`bt_id`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Site Bills Module Transactions Table';
CREATE TABLE IF NOT EXISTS %PREFIX%suppliers (`s_id` int(11) NOT NULL default '0', `s_status` varchar(20) NOT NULL default 'pending', `s_company` varchar(50) NOT NULL default '', `s_name_first` varchar(20) NOT NULL default '', `s_name_last` varchar(20) NOT NULL default '', `s_addr_01` varchar(50) NOT NULL default '', `s_addr_02` varchar(50) NOT NULL default '', `s_city` varchar(50) NOT NULL default '', `s_state_prov` varchar(50) NOT NULL default '', `s_country` varchar(50) NOT NULL default '', `s_zip_code` varchar(12) NOT NULL default '', `s_phone` varchar(20) NOT NULL default '', `s_fax` varchar(20) NOT NULL default '', `s_tollfree` varchar(20) NOT NULL default '', `s_email` varchar(50) NOT NULL default '', `s_taxid` varchar(20) NOT NULL default '', `s_account` varchar(20) NOT NULL default '', `s_terms` varchar(20) NOT NULL, `s_notes` text NOT NULL, PRIMARY KEY (`s_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Site Suppliers Module Table';
CREATE TABLE IF NOT EXISTS %PREFIX%suppliers_contacts (`contacts_id` int(11) NOT NULL auto_increment, `contacts_s_id` int(11) NOT NULL default '0', `contacts_name_first` varchar(20) NOT NULL default '', `contacts_name_last` varchar(20) NOT NULL default '', `contacts_email` varchar(50) NOT NULL default '', UNIQUE KEY `contacts_id` (`contacts_id`), KEY `contacts_s_id` (`contacts_s_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Site Suppliers Additional Emails Table';
CREATE TABLE %PREFIX%versions (v_id smallint(6) NOT NULL auto_increment, v_ts varchar(10) NOT NULL default '', v_ver varchar(8) NOT NULL default '', v_type varchar(10) NOT NULL default 'Install', PRIMARY KEY (v_id)) TYPE=MyISAM COMMENT='Package Versions Table' AUTO_INCREMENT=2;
INSERT INTO %PREFIX%versions (`v_id`, `v_ts`, `v_ver`, `v_type`) VALUES (1, '%TIMESTAMP%', 'v1.5.1', 'Install');